
# line 2 "rnpl.y"
/* grammar for RNPL */
/* $Header: /home/felipe/rmarsa/source/rnpl/RCS/rnpl.y,v 2.10 1996/08/06 20:18:40 rmarsa Exp $ */
/* Copyright (c) 1994-1996 by Robert L. Marsa */

#define VERSION "0.92"

#include "rnpl.h"

BBH_C default_rnpl_path[]=BBH_RNPL_DEFAULT_PATH;

param_dec *pd;
coord_dec *cd;
grid_list *gd;
gfunc_list *gf;
attrib_dec *ad;
operator *od;
residual *rd;
init_dec *id;
name_list *ld;
update *ud;

BBH_V setup_tables();

extern FILE *yyin;

# line 28 "rnpl.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
	BBH_I inum;
	BBH_D num;
	BBH_C op;
	d_op *deriv;
	func *fnc;
	i_reg *ireg;
	c_reg *creg;
	gfunction *gfunc;
	residual *resid;
	operator *doper;
	offset_type *olst;
	grid_list *grlst;
	gfunc_list *gfnlst;
	name_list *nml;
	coord_list *crd;
	coord_dec *crdec;
	update *updt;
	BBH_C *ident;
	BBH_C *str;
	node *nd;
	param_dec *pdec;
	attrib_dec *atdec;
	coord_ref *cdnt;
	scalar sclr;
	scalar_list *sclrlst;
	init_dec *indec;
	res_list *rlst;
	ref_list *rflst;
	indel *ndl;
	index_list *indl;
	ifstat *ifs;
	ivec_list *ivlst;
} YYSTYPE;
# define IDEN 257
# define STR 258
# define OP 259
# define NUM 260
# define INUM 261
# define INT 262
# define FLOAT 263
# define STRING 264
# define COORDINATES 265
# define GRID 266
# define ON 267
# define PARAM 268
# define AUTO 269
# define STUB 270
# define ASSIGNOP 271
# define RESID 272
# define UPDATE 273
# define C 274
# define CPP 275
# define F77 276
# define F90 277
# define UNIFORM 278
# define NONUNIFORM 279
# define AT 280
# define ALIAS 281
# define OPERATOR 282
# define QUOTE 283
# define EXPAND 284
# define FUNC 285
# define D_OP 286
# define GFUNC 287
# define COORD 288
# define STATIC 289
# define CONST 290
# define COMMA 291
# define OBRACK 292
# define CBRACK 293
# define OBRACE 294
# define CBRACE 295
# define OPAREN 296
# define CPAREN 297
# define COLON 298
# define ATTRIB 299
# define ENCODEALL 300
# define ENCODEONE 301
# define INITIALIZE 302
# define LOOPER 303
# define SCOLON 304
# define EVALUATE 305
# define HEADER 306
# define WORK 307
# define POUND 308
# define UPFILE 309
# define CDIF 310
# define GBASE 311
# define SYS 312
# define OFFS 313
# define EXPR 314
# define TIME 315
# define IF 316
# define THEN 317
# define ELSE 318
# define IVEC 319
# define RNPL 320
# define DAGH 321
# define EQUALS 322
# define OR 323
# define AND 324
# define EQUIV 325
# define NOTEQ 326
# define GREAT 327
# define LESS 328
# define GREATEQ 329
# define LESSEQ 330
# define PLUS 331
# define MINUS 332
# define TIMES 333
# define DIVIDE 334
# define UMINUS 335
# define CARET 336

#include <malloc.h>
#include <memory.h>
#include <unistd.h>
#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif
#ifndef yylex
	extern "C" int yylex(void);
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 1175 "rnpl.y"


main(BBH_I argc, BBH_C **argv)
{
	BBH_I fn,rn,gn,i,err;
	BBH_C *fnm,ch,line[1024],oname[100],iname[50],ifile[100],*ev;
	coord_list *co,*nm;
	i_reg *ir;
	c_reg *cr;
	statement_list *stl;
	FILE *fpin,*fpout,*fpout_init,*fpout_inc,*fpout_inc1,*fpout_upd;
	FILE *fpinit_frag;
	name_list *n;
	BBH_I ostd=0,argerr=0,opt,oopt=0,lang=0;
	extern char *optarg;
	extern int optind,opterr,optopt;
	name_list *nlp;

	while((opt=getopt(argc,argv,"a:c:l:o:p"))!=EOF){
		switch(opt){
			case 'a' :
				if(!strcmp(optarg,"RNPL"))
					adapt=RNPL;
				else if(!strcmp(optarg,"DAGH"))
					adapt=DAGH;
				else {
					fprintf(stderr,"Invalid adaptive option <%s>\n",optarg);
					argerr=1;
				}
				break;
			case 'c' :
				if(!strcmp(optarg,"sufD"))
					fort_const_D=1;
				else if(!strcmp(optarg,"sufE"))
					fort_const_D=0;
				else{
					fprintf(stderr,"Invalid FORTRAN constant option <%s>\n",optarg);
					fprintf(stderr,"Defaulting to <sufD>\n");
					fort_const_D=1;
				}
				break;
			case 'l' :
				if(!strcmp(optarg,"c")){
					language=C;
				}else if(!strcmp(optarg,"c++")){
					language=CPP;
				}else if(!strcmp(optarg,"f77")){
					language=F77;
				}else if(!strcmp(optarg,"f90")){
					language=F90;
				}else{
					fprintf(stderr,"Invalid language <%s>\n",optarg);
					argerr=1;
				}
				lang=1;
				break;
			case 'o' :
				if(optarg[0]=='-'){
					fprintf(stderr,"Invalid output file name <%s>\n",optarg);
					argerr=1;
				}else{
					strcpy(oname,optarg);
					oopt=1;
				}
				break;
			case 'p' :
				parallel=DAGH;
				break;
			case '?' :
				argerr=1;
				break;
		}
	}
	if(argerr || !lang){
		fprintf(stderr,"  RNPL version: %s\n",VERSION);
		fprintf(stderr,"  Compiler Copyright (c) 1994-1996 by Robert L. Marsa\n");
		fprintf(stderr,"  Language Copyright (c) 1994-1996 by Robert L. Marsa and Matthew W. Choptuik\n\n");
		fprintf(stderr,"Usage: \n");
		fprintf(stderr,"  rnpl   -l { c | c++ | f77 | f90 }\n");
		fprintf(stderr,"       [ -c { sufD | sufE } ]\n");
		fprintf(stderr,"       [ -o output_stem ]\n");
		fprintf(stderr,"       [ -a { RNPL | DAGH } ]\n"); 
		fprintf(stderr,"       [ -p ]\n");
		fprintf(stderr,"       [ input_file ]\n\n");
		fprintf(stderr,"  -l selects the output language\n");
		fprintf(stderr,"  -c selects whether FORTRAN constants are written as D0 or E0\n");
		fprintf(stderr,"  -o selects stem of output file names\n");
		fprintf(stderr,"     (defaults to the same as the input file stem)\n");
		fprintf(stderr,"  -a selects which system will be used to produce the\n");
		fprintf(stderr,"     adaptive driver if adaptivity is indicated in the source\n");
		fprintf(stderr,"  -p turns on parallel output using DAGH\n");
		fprintf(stderr,"  If no input_file is specified, the compiler will read from\n");
		fprintf(stderr,"  stdin.  If in addition, no output stem is specified, the compiler\n");
		fprintf(stderr,"  will send the evolution code to stdout, while the initial data\n");
		fprintf(stderr,"  code will be written to <r_out_init>.\n\n");
		exit(0);
	}
	if(optind<argc){
		fpin=fopen(argv[optind],"r");
		if(fpin==NULL){
			fprintf(stderr,"RNPL: Unable to open <%s>\n",argv[optind]);
			exit(0);
		}
		yyin=fpin;
		if(!oopt && (!strcmp(argv[optind]+strlen(argv[optind])-5,"_rnpl") || 
		   !strcmp(argv[optind]+strlen(argv[optind])-5,".rnpl"))){
			strncpy(oname,argv[optind],strlen(argv[optind])-5);
			oname[strlen(argv[optind])-5]=0;
		}else if(!oopt) strcpy(oname,argv[2]);
		strcpy(iname,oname);
		strcat(iname,"_init");
	}else if(oopt){
		strcpy(iname,oname);
		strcat(iname,"_init");
	}else{
		ostd=1;
		strcpy(iname,"r_out_init");
		oname[0]=0;
	}

	if(language==C || language==CPP){
		strcat(iname,".c");
		strcat(oname,".c");
	}else if(language==F77 || language==F90){
		strcat(iname,".f");
		strcat(oname,".f");
	}
	
#ifdef RNPLDEBUG
fprintf(stderr,"iname=%s\n",iname);
fprintf(stderr,"oname=%s\n",oname);
#endif

	/* setup directory path */
	ev=getenv("RNPL_PATH");
	if(ev!=NULL)
		strcpy(ldir,ev);
	else
		strcpy(ldir,default_rnpl_path);

#ifdef RNPLDEBUG
fprintf(stderr,"ldir=%s\n",ldir);
#endif

	str_tbl.next=NULL;
	str_tbl.n=NULL;

	add_name("stub");
	add_name("auto");
	/* add "special" parameters */
	add_name("epsiter");
	add_name("start_t");
	add_name("iter");
	add_name("fout");
	add_name("ser");
	add_name("output");
	add_name("lambda");
	add_name("in_file");
	add_name("out_file");
	add_name("level");
	add_name("tag");
	add_name("s_step");
	add_name("out_gf");
	if(language == F77 || language == F90)
		add_name("memsiz");

	/* add functions to string table */
	Ln=add_name("log");
	Sin=add_name("sin");
	Cos=add_name("cos");
	Exp=add_name("exp");
	Tan=add_name("tan");
	Sqrt=add_name("sqrt");
	Sinh=add_name("sinh");
	Cosh=add_name("cosh");
	Tanh=add_name("tanh");

	/* setup declaration pointers */
	pd=NULL;
	cd=NULL;
	gd=NULL;
	gf=NULL;
	ad=NULL;
	od=NULL;
	rd=NULL;
	id=NULL;
	ld=NULL;
	ud=NULL;

#ifdef RNPLDEBUG
fprintf(stderr,"Before yyparse\n");
#endif

	yyparse();

#ifdef RNPLDEBUG
fprintf(stderr,"After yyparse\n");
#endif

	if(!ostd){
		fclose(fpin);
		fpout=fopen(oname,"w");
		if(fpout==NULL){
			fprintf(stderr,"Unable to open <%s> for output.\n",oname);
			exit(0);
		}
	}else fpout=stdout;
	fpout_init=fopen(iname,"w");
	if(fpout_init==NULL){
		fprintf(stderr,"Unable to open <%s> for output.\n",iname);
		exit(0);
	}

	setup_tables();
	
	/* error checking */
	/* check operators for: */
	/*  d_ops must have all coordinates in same system */
	/*  gfunc in d_op (f) must have correct rank in op_expr */
	/* check residuals for: */
	/*   each gfunc in a d_op must have the correct coordinates */
	
	/* check for undeclared names */
	/*
	for(nlp=str_tbl.next;nlp!=NULL;nlp=nlp->next)
		if(name_type(nlp)==-1)
			fprintf(stderr,"Error: <%s> is undeclared.\n",nlp->n);
  */
	for(i=0;i<nopers;i++){
#ifdef RNPLDEBUG
fprintf(stderr,"dopers[%d].op_expr=",i);
ex_to_string(stderr,dopers[i].op_expr);
fprintf(stderr,"\n");
#endif
		expand_expr(dopers[i].op_expr);
#ifdef RNPLDEBUG
fprintf(stderr,"expanded dopers[%d].op_expr=",i);
ex_to_string(stderr,dopers[i].op_expr);
fprintf(stderr,"\n");
#endif
		evaluate_expr(dopers[i].op_expr);
#ifdef RNPLDEBUG
fprintf(stderr,"evaluated dopers[%d].op_expr=",i);
ex_to_string(stderr,dopers[i].op_expr);
fprintf(stderr,"\n");
#endif
	}
	
	/* substitute operators into residuals */
	for(rn=0;rn<nresids;rn++){
		if(resids[rn].etype==1){
			expand_expr(resids[rn].elst.expr);
			evaluate_expr(resids[rn].elst.expr);
			offset_expr(resids[rn].toff,resids[rn].indx,resids[rn].elst.expr);
			simplify_expr(resids[rn].elst.expr); 
		}else{
			expand_ifstat(resids[rn].elst.ifst);
			evaluate_ifstat(resids[rn].elst.ifst);
			offset_ifstat(resids[rn].toff,resids[rn].indx,resids[rn].elst.ifst);
			simplify_ifstat(resids[rn].elst.ifst);
		}
	}
	

#ifdef RNPLDEBUG
fprintf(stderr,"substituted operators into residuals\n");
#endif
	
	/* check residuals for undeclared names, mascarading gfuncs and coords */
	for(rn=0;rn<nresids;rn++){
		for(ir=resids[rn].reg;ir!=NULL;ir=ir->next){
			if(!check_expr(ir->lower) || !check_simp_expr(ir->lower) ||
			   !check_expr(ir->upper) || !check_simp_expr(ir->upper)){
				fprintf(stderr,"Error: residual %d for %s has a bad index expression\n",rn,
								resids[rn].gfunc->fname->n);
				fatal_error("Expression specification.");
			}
		}
		if(resids[rn].etype==1){
			if(!check_expr(resids[rn].elst.expr) || !check_gen_expr(resids[rn].elst.expr)){
				fprintf(stderr,"Error: residual %d for %s has an expression error\n",rn,
								resids[rn].gfunc->fname->n);
				fatal_error("Expression specification.");
			}
		}else{
			if(!check_ifstat(resids[rn].elst.ifst) || !check_gen_ifstat(resids[rn].elst.ifst)){
				fprintf(stderr,"Error: residual %d for %s\n",rn,resids[rn].gfunc->fname->n);
				fatal_error("Expression specification.");
			}
		}
	}
	
	/* check residuals for time levels */
	/* check residuals for ranges */
	
#ifdef RNPLDEBUG
fprintf(stderr,"residual expressions\n");
#endif

	/* substitutions into initializations */
	for(i=0;i<ninits;i++){
		if(inits[i].etype==1){
			expand_expr(inits[i].elst.expr);
			evaluate_expr(inits[i].elst.expr);
			simplify_expr(inits[i].elst.expr); 
		}else{
			expand_ifstat(inits[i].elst.ifst);
			evaluate_ifstat(inits[i].elst.ifst);
			simplify_ifstat(inits[i].elst.ifst);
		}
	}

#ifdef RNPLDEBUG
fprintf(stderr,"initialization expressions\n");
#endif
	/* check initializations for undeclared names */

	for(i=0;i<ninits;i++){
		for(ir=inits[i].reg;ir!=NULL;ir=ir->next){
			if(!check_expr(ir->lower) || !check_simp_expr(ir->lower) ||
			   !check_expr(ir->upper) || !check_simp_expr(ir->upper)){
				fprintf(stderr,"Error: initialization %d for %s has a bad index expression\n",i,
								inits[i].gfunc->fname->n);
				fatal_error("Expression specification.");
			}
		}
		if(inits[i].etype==1){
			if(!check_expr(inits[i].elst.expr) || !check_gen_expr(inits[i].elst.expr)){
				fprintf(stderr,"Error: initialization %d for %s has an expression error\n",i,
								inits[i].gfunc->fname->n);
				fatal_error("Expression specification.");
			}
		}else{
			if(!check_ifstat(inits[i].elst.ifst) || !check_gen_ifstat(inits[i].elst.ifst)){
				fprintf(stderr,"Error: initialization %d for %s\n",i,inits[i].gfunc->fname->n);
				fatal_error("Expression specification.");
			}
		}
	}

	/* build reference lists */
	/* first resid for any gfunc contains complete reference lists */
	/* subsequent resids contain only local ref lists */
	/* updates contain complete gfunc reference lists */

	for(rn=0;rn<nresids;rn++)
		resids[rn].output=0;
		
	/* do residuals */	
	for(rn=0;rn<nresids;rn++){
		name_list *nm;
		gfunc_ref_list *grl,*tgl,*gl;
		coord_list *gcl,*tcl,*cl;
		coord_list *gcd,*tcd,*cd;
		param_ref_list *prl,*tpl,*pl;
		if(!resids[rn].output){
			resids[rn].output=1;
			nm=resids[rn].gfunc->fname;
			if(resids[rn].etype==1){
				grl=find_gfuncs(resids[rn].elst.expr);
				gcl=find_coords(resids[rn].elst.expr);
				gcd=find_cdifs(resids[rn].elst.expr);
				prl=find_params(resids[rn].elst.expr);
			}else{
				grl=find_gfuncs_if(resids[rn].elst.ifst);
				gcl=find_coords_if(resids[rn].elst.ifst);
				gcd=find_cdifs_if(resids[rn].elst.ifst);
				prl=find_params_if(resids[rn].elst.ifst);
			}
			resids[rn].gf_refs=dup_gf_ref(grl);
			resids[rn].crds=dup_clst(gcl);
			resids[rn].cdifs=dup_clst(gcl);
			resids[rn].parms=dup_param_ref(prl);
			for(i=rn+1;i<nresids && resids[i].gfunc->fname==nm;i++){
				resids[i].output=1;
				if(resids[i].etype==1){
					resids[i].gf_refs=find_gfuncs(resids[i].elst.expr);
					resids[i].crds=find_coords(resids[i].elst.expr);
					resids[i].cdifs=find_cdifs(resids[i].elst.expr);
					resids[i].parms=find_params(resids[i].elst.expr);
				}else{
					resids[i].gf_refs=find_gfuncs_if(resids[i].elst.ifst);
					resids[i].crds=find_coords_if(resids[i].elst.ifst);
					resids[i].cdifs=find_cdifs_if(resids[i].elst.ifst);
					resids[i].parms=find_params_if(resids[i].elst.ifst);
				}
				resids[i].glob_gf=NULL;
				resids[i].glob_crds=NULL;
				resids[i].glob_cdifs=NULL;
				resids[i].glob_par=NULL;
				if(grl){
					for(tgl=resids[i].gf_refs;tgl!=NULL;tgl=tgl->next){
						gl=new_gfunc_ref();
						gl->gfunc=tgl->gfunc;
						gl->toff=tgl->toff;
						add_gfunc_ref(grl,gl);
					}
				}else grl=dup_gf_ref(resids[i].gf_refs);
				if(gcl){
					for(tcl=resids[i].crds;tcl!=NULL;tcl=tcl->next){
						cl=new_coord_list();
						cl->name=tcl->name;
						add_name_ref(gcl,cl);
					}
				}else gcl=dup_clst(resids[i].crds);
				if(gcd){
					for(tcd=resids[i].cdifs;tcd!=NULL;tcd=tcd->next){
						cd=new_coord_list();
						cd->name=tcd->name;
						add_name_ref(gcd,cd);
					}
				}else gcd=dup_clst(resids[i].cdifs);
				if(prl){
					for(tpl=resids[i].parms;tpl!=NULL;tpl=tpl->next){
						pl=new_param_ref();
						pl->par=tpl->par;
						add_param_ref(prl,pl);
					}
				}else prl=dup_param_ref(resids[i].parms);
			}
			resids[rn].glob_gf=grl;
			resids[rn].glob_crds=gcl;
			resids[rn].glob_cdifs=gcd;
			resids[rn].glob_par=prl;
		}
	}

#ifdef RNPLDEBUG
fprintf(stderr,"residual refs\n");
#endif

	/* do updates */
  for(i=0;i<nupdates;i++){ /* loop over updates */
		gfunc_tab_list *gtl;
		gfunc_ref_list *tgl,*gl;
		coord_list *tcl,*cl;
		param_ref_list *tpl,*pl;
		if(!updates[i].header){
			for(gtl=updates[i].gfs;gtl!=NULL;gtl=gtl->next){ /* loop over gfuncs */
				rn=resid_exists(gtl->gfunc->fname);
				if(rn==-1){
					fprintf(stderr,"Update %d ",i);
					if(updates[i].name)
						fprintf(stderr,"(%s) ",updates[i].name->n);
					fprintf(stderr,"defined for %s has no header or residual.\n",
									gtl->gfunc->fname->n);
					fatal_error("Specification error.");
				}
				if(updates[i].glob_gf){ /* if list not empty, add new items */
					for(tgl=resids[rn].glob_gf;tgl!=NULL;tgl=tgl->next){
						gl=new_gfunc_ref();
						gl->gfunc=tgl->gfunc;
						gl->toff=tgl->toff;
						add_gfunc_ref(updates[i].glob_gf,gl);
					}
				}else updates[i].glob_gf=dup_gf_ref(resids[rn].glob_gf); /* copy */
				if(updates[i].glob_crds){ /* if list not empty, add new items */
					for(tcl=resids[rn].glob_crds;tcl!=NULL;tcl=tcl->next){
						cl=new_coord_list();
						cl->name=tcl->name;
						add_name_ref(updates[i].glob_crds,cl);
					}
				}else updates[i].glob_crds=dup_clst(resids[rn].glob_crds); /* copy */
				if(updates[i].glob_cdifs){ /* if list not empty, add new items */
					for(tcl=resids[rn].glob_cdifs;tcl!=NULL;tcl=tcl->next){
						cl=new_coord_list();
						cl->name=tcl->name;
						add_name_ref(updates[i].glob_cdifs,cl);
					}
				}else updates[i].glob_cdifs=dup_clst(resids[rn].glob_cdifs); /* copy */
				if(updates[i].glob_par){ /* if list is not empty, add new items */
					for(tpl=resids[rn].glob_par;tpl!=NULL;tpl=tpl->next){
						pl=new_param_ref();
						pl->par=tpl->par;
						add_param_ref(updates[i].glob_par,pl);
					}
				}else updates[i].glob_par=dup_param_ref(resids[rn].glob_par);
			}
		}
	}
	
#ifdef RNPLDEBUG
fprintf(stderr,"update refs\n");
#endif

	/* set up list of static work arrays */
	static_work=NULL;
	for(i=0;i<nupdates;i++){
		work_list *wl,*wn;
		work_array *wk;
		for(wl=updates[i].work_refs;wl!=NULL;wl=wl->next){
			if(!wl->work->ato){ /* if static, dup and add to list */
				wk=new_work_array();
				wk->ato=0;
				wk->num=wl->work->num;
				wk->expr=dup_expr(wl->work->expr);
				wn=new_work_list();
				wn->work=wk;
				if(static_work)
					add_work_ref(static_work,wn);
				else static_work=wn;
			}
		}
	}

#ifdef RNPLDEBUG
fprintf(stderr,"static work arrays\n");
#endif

	for(rn=0;rn<nresids;resids[rn++].output=0);

	/* output evolution program */
	sprintf(oname,"%s/rnpl_evol_dir",ldir);
	switch(language){
		case C	 :	strcat(oname,"_c");
								fpout_inc=fpout;
								fpout_inc1=fpout;
								fpout_upd=fopen("updates.h","w");
								if(fpout_upd==NULL)
									fatal_error("Can't open updates.h");
								break;
		case F77 :	strcat(oname,"_f77");
#ifdef RNPLDEBUG
fprintf(stderr,"oname=%s\n",oname);
#endif
								fpout_inc=fopen("globals.inc","w");
								if(fpout_inc==NULL)
									fatal_error("Can't open globals.inc");
								fpout_inc1=fopen("other_glbs.inc","w");
								if(fpout_inc1==NULL)
									fatal_error("Can't open other_glbs.inc");
								fpout_upd=fopen("updates.f","w");
								if(fpout_upd==NULL)
									fatal_error("Can't open updates.f");
								fpinit_frag=fopen("initfrag.f","w");
								if(fpinit_frag==NULL)
									fatal_error("Can't open initfrag.f");
								break;
		case F90 :	strcat(oname,"_f90");
								break;
	}
	fpin=fopen(oname,"r");
	if(fpin==NULL){
		fprintf(stderr,"Can't open output direction file %s.\n",oname);
		exit(0);
	}

#ifdef RNPLDEBUG
fprintf(stderr,"Opened output direction file\n");
#endif

	stmts=NULL;
	while(fgets(line,1024,fpin)){
		statement_list *p,*q;
		BBH_I l;
		
#ifdef RNPLDEBUG
fprintf(stderr,"line=%s\n",line);
#endif

		if(line[0]=='\"'){ /* include */
			p=new_statement_list();
			p->type=1;
			l=strlen(line);
			p->str=new_string(l-2);
			strncpy(p->str,line+1,l-3);
			p->str[l-3]=0;
			p->next=NULL;
			if(stmts){
				for(q=stmts;q->next!=NULL;q=q->next);
				q->next=p;
			}else stmts=p;
		}else{ /* statement */
			p=new_statement_list();
			p->type=0;
			l=strlen(line);
			p->str=new_string(l);
			strncpy(p->str,line,l-1);
			p->str[l-1]=0;
			p->next=NULL;
			if(stmts){
				for(q=stmts;q->next!=NULL;q=q->next);
				q->next=p;
			}else stmts=p;
		}
	}
	fclose(fpin);
	
#ifdef RNPLDEBUG
fprintf(stderr,"opened files, read dir files\n");
#endif

	for(stl=stmts;stl!=NULL;stl=stl->next){
		if(stl->type==1){
			sprintf(ifile,"%s/%s",ldir,stl->str);
			fpin=fopen(ifile,"r");
			if(fpin==NULL){
				fprintf(stderr,"Can't open include file %s.\n",stl->str);
			}else{ /* include files are copied as is */
				while(fgets(line,1024,fpin))
					fprintf(fpout,"%s",line);
				fclose(fpin);
			}
		}else if(stl->type==0){
			if(!strcmp(stl->str,"declare_coord_difs")){
				declare_coord_difs(fpout_inc1); 

#ifdef RNPLDEBUG
fprintf(stderr,"declare_coord_difs\n");
#endif

			}else if(!strcmp(stl->str,"declare_parameters")){
				declare_parameters(fpout_inc);

#ifdef RNPLDEBUG
fprintf(stderr,"declare_parameters\n");
#endif

			}else if(!strcmp(stl->str,"declare_grids")){
				declare_grids(fpout_inc); 

#ifdef RNPLDEBUG
fprintf(stderr,"declare_grids\n");
#endif

			}else if(!strcmp(stl->str,"declare_gfuncs")){
				declare_gfuncs(fpout_inc);

#ifdef RNPLDEBUG
fprintf(stderr,"declare_gfuncs\n");
#endif

			}else if(!strcmp(stl->str,"declare_attributes")){
				declare_attributes(fpout_inc); 

#ifdef RNPLDEBUG
fprintf(stderr,"declare_attributes\n");
#endif

			}else if(!strcmp(stl->str,"code_residuals")){
				code_residuals(fpout); 

#ifdef RNPLDEBUG
fprintf(stderr,"code_residuals\n");
#endif

			}else if(!strcmp(stl->str,"swap_levels")){
				swap_levels(fpout); 

#ifdef RNPLDEBUG
fprintf(stderr,"swap_levels\n");
#endif

			}else if(!strcmp(stl->str,"one_step")){
				one_step(fpout_upd); 

#ifdef RNPLDEBUG
fprintf(stderr,"one_step\n");
#endif

			}else if(!strcmp(stl->str,"code_updates")){
				code_updates(fpout); 

#ifdef RNPLDEBUG
fprintf(stderr,"code_updates\n");
#endif

			}else if(!strcmp(stl->str,"init_params_attribs")){
				init_params_attribs(fpout);

#ifdef RNPLDEBUG
fprintf(stderr,"init_params_attribs\n");
#endif

			}else if(!strcmp(stl->str,"init_coord_difs")){
				init_coord_difs(fpout); 

#ifdef RNPLDEBUG
fprintf(stderr,"init_coord_difs\n");
#endif

			}else if(!strcmp(stl->str,"init_grids")){
				init_grids(fpout); 

#ifdef RNPLDEBUG
fprintf(stderr,"init_grids\n");
#endif

			}else if(!strcmp(stl->str,"init_gfuncs")){
				init_gfuncs(fpout);

#ifdef RNPLDEBUG
fprintf(stderr,"init_gfuncs\n");
#endif

			}else if(!strcmp(stl->str,"read_gfuncs")){
				read_gfuncs(fpout,iname);

#ifdef RNPLDEBUG
fprintf(stderr,"read_gfuncs\n");
#endif

			}else if(!strcmp(stl->str,"dump_state")){
				dump_state(fpout);

#ifdef RNPLDEBUG
fprintf(stderr,"dump_state\n");
#endif

			}else if(!strcmp(stl->str,"write_attributes")){
				write_attributes(fpout);

#ifdef RNPLDEBUG
fprintf(stderr,"write_attributes\n");
#endif

			}else if(!strcmp(stl->str,"cleanup")){
				cleanup(fpout);

#ifdef RNPLDEBUG
fprintf(stderr,"cleanup\n");
#endif

			}else if(!strcmp(stl->str,"handler")){
				handler(fpout);

#ifdef RNPLDEBUG
fprintf(stderr,"handler\n");
#endif

			}
		}
	}

#ifdef RNPLDEBUG
fprintf(stderr,"Did evolver\n");
#endif

	/* output initial data generator */

	sprintf(oname,"%s/rnpl_init_dir",ldir);
	switch(language){
		case C	 : strcat(oname,"_c");
							 break;
		case F77 : strcat(oname,"_f77");
							 break;
		case F90 : strcat(oname,"_f90");
							 break;
	}
	fpin=fopen(oname,"r");
	if(fpin==NULL){
		fprintf(stderr,"Can't open output direction file %s.\n",oname);
		exit(0);
	}
	stmts=NULL;
	while(fgets(line,1024,fpin)){
		statement_list *p,*q;
		BBH_I l;
		
		if(line[0]=='\"'){ /* include */
			p=new_statement_list();
			p->type=1;
			l=strlen(line);
			p->str=new_string(l-2);
			strncpy(p->str,line+1,l-3);
			p->str[l-3]=0;
			p->next=NULL;
			if(stmts){
				for(q=stmts;q->next!=NULL;q=q->next);
				q->next=p;
			}else stmts=p;
		}else{ /* statement */
			p=new_statement_list();
			p->type=0;
			l=strlen(line);
			p->str=new_string(l);
			strncpy(p->str,line,l-1);
			p->str[l-1]=0;
			p->next=NULL;
			if(stmts){
				for(q=stmts;q->next!=NULL;q=q->next);
				q->next=p;
			}else stmts=p;
		}
	}
	fclose(fpin);
	
	for(stl=stmts;stl!=NULL;stl=stl->next){
		if(stl->type==1){
			sprintf(ifile,"%s/%s",ldir,stl->str);
			fpin=fopen(ifile,"r");
			if(fpin==NULL){
				fprintf(stderr,"Can't open include file %s.\n",stl->str);
			}else{ /* include files are copied as is */
				while(fgets(line,1024,fpin))
					fprintf(fpout_init,"%s",line);
				fclose(fpin);
			}
		}else if(stl->type==0){
			if(!strcmp(stl->str,"declare_coord_difs")){
				declare_coord_difs(fpout_init);
			}else if(!strcmp(stl->str,"declare_parameters")){
				declare_parameters(fpout_init);
			}else if(!strcmp(stl->str,"declare_grids")){
				declare_grids(fpout_init);
			}else if(!strcmp(stl->str,"declare_gfuncs")){
				declare_gfuncs(fpout_init);
			}else if(!strcmp(stl->str,"declare_attributes")){
				declare_attributes(fpout_init);
			}else if(!strcmp(stl->str,"code_residuals")){
				code_residuals(fpout_init);
			}else if(!strcmp(stl->str,"swap_top")){
				swap_top(fpout_init); 
			}else if(!strcmp(stl->str,"one_step")){
				one_step(fpout_init); 
			}else if(!strcmp(stl->str,"code_iteration")){
				code_iteration(fpout_init);
			}else if(!strcmp(stl->str,"init_params_attribs")){
				init_params_attribs(fpout_init);
			}else if(!strcmp(stl->str,"init_coord_difs")){
				init_coord_difs(fpout_init);
			}else if(!strcmp(stl->str,"init_grids")){
				init_grids(fpout_init);
			}else if(!strcmp(stl->str,"init_gfuncs")){
				init_gfuncs(fpout_init);
			}else if(!strcmp(stl->str,"gen_gfuncs")){
				gen_gfuncs(fpout_init);
			}else if(!strcmp(stl->str,"dump_state")){
				dump_state(fpout_init);
			}else if(!strcmp(stl->str,"write_attributes")){
				write_attributes(fpout_init);
			}else if(!strcmp(stl->str,"init_fragment")){
				init_fragment(fpinit_frag);
			}else if(!strcmp(stl->str,"cleanup")){
				cleanup(fpout_init);
			}
		}
	}
	fclose(fpout_inc);
	fclose(fpout_inc1);
	fclose(fpout_init);
	fclose(fpout);
	if((fpout=fopen(".rnpl.attributes","w"))==NULL)
		fatal_error("Can't open .rnpl.attributes.");
	else {
		offset_type *o;
		fprintf(fpout,"%d\n",nattribs);
		for(i=0;i<nattribs;i++){
			fprintf(fpout,"%s\n",attribs[i].name->n);
			fprintf(fpout,"%d\n",attribs[i].size);
			if(attribs[i].encoding==ENCODEONE){
				for(fn=0;fn<ngfuncs;fn++)
					fprintf(fpout,"%s ",gfuncs[fn].fname->n);
			}else { /* ENCODEALL */
				for(fn=0;fn<ngfuncs;fn++)
					for(o=gfuncs[fn].tlev;o!=NULL;o=o->next){
						fprintf(fpout,gfuncs[fn].fname->n);
						gfunc_suffix(fpout,o->offset);
						fprintf(fpout," ");
					}
			}
			for(rn=0;rn<nresids;){
				if(resids[rn].eval)
					fprintf(fpout,"%s_res ",resids[rn].gfunc->fname->n);
				for(++rn;rn<nresids && resids[rn].gfunc==resids[rn-1].gfunc;rn++);
			}
			fprintf(fpout,"\n%s := ",attribs[i].name->n);
			if(attribs[i].size>1)
				fprintf(fpout,"[ ");
			if(attribs[i].def){
				for(fn=0;fn<attribs[i].size;fn++)
					switch(attribs[i].type){
						case INT		: fprintf(fpout,"%d ",attribs[i].def_val.i_ar[fn]);
													break;
						case FLOAT	:	fprintf(fpout,"%.16g ",attribs[i].def_val.f_ar[fn]);
													break;
						case STRING	: if(attribs[i].def_val.s_ar[rn]!=NULL)
														fprintf(fpout,"\"%s\" ",attribs[i].def_val.s_ar[fn]);
													else fprintf(fpout,"\" \" ");
													break;
					}
			}else{
				for(fn=0;fn<attribs[i].size;fn++)
					switch(attribs[i].type){
						case INT		:
						case FLOAT	: fprintf(fpout,"0 ");
													break;
						case STRING	: fprintf(fpout,"\" \" ");
													break;
					}
			}
			if(attribs[i].size>1)
				fprintf(fpout,"]\n");			
		}
		fclose(fpout);
	}
}

BBH_V setup_tables()
{
	BBH_I an,gn,fn,dn,rn,i,pn;
	param_dec *pl,*np;
	grid_list *g;
	gfunc_list *f;
	attrib_dec *al,*na;
	init_dec *ind;
	operator *o;
	residual *r;
	res_list *rl;
	update *u;
	i_reg *p;
	c_reg *q;
	BBH_C *fnm;
	coord_list *co,*nm;
	gfunc_tab_list *gft;
	coord_dec *crd;


#ifdef RNPLDEBUG
fprintf(stderr,"Setting up tables\n");
#endif

	/* setup coordinates */
	for(gn=0,crd=cd;crd!=NULL;crd=crd->next,gn++);
	if(cd==NULL)
		fatal_error("No coordinate system.");
	if((coords=(coord_table *)malloc(gn*sizeof(coord_table)))==NULL)
		fatal_error("Can't malloc coord_table.");
	ncoords=gn;
	for(--gn,crd=cd;gn>=0;gn--,crd=crd->next){ /* reverse order */
		coords[gn].rank=crd->rank;
		coords[gn].name=crd->name;
		coords[gn].c_names=crd->c_names;
	}
			 
	if((coord_difs=(name_list ***)malloc(ncoords*sizeof(name_list **)))==NULL)
		fatal_error("Can't malloc coord_difs.");
	for(gn=0;gn<ncoords;gn++)
		if((coord_difs[gn]=(name_list **)malloc(coords[gn].rank*sizeof(name_list *)))==NULL)
			fatal_error("Can't malloc coord_difs num.");
 
	if((grid_base=(name_list ***)malloc(ncoords*sizeof(name_list **)))==NULL)
		fatal_error("Can't malloc grid_base.");
	for(gn=0;gn<ncoords;gn++)
		if((grid_base[gn]=(name_list **)malloc((coords[gn].rank-1)*sizeof(name_list *)))==NULL)
			fatal_error("Can't malloc grid_base num.");
		 

#ifdef RNPLDEBUG
fprintf(stderr,"setup coordinates\n");
fprintf(stderr,"ncoords=%d\n",ncoords);
for(i=0;i<ncoords;i++)
	fprintf(stderr,"coords[%d].name=%s\n",i,coords[i].name->n);
#endif

	/* error checking */
	/* make sure there are no duplicates amoung spacial coordinates */
	for(co=coords[0].c_names->next,i=1;i<coords[0].rank;i++,co=co->next)
	 for(nm=coords[0].c_names,gn=0;gn<i;gn++,nm=nm->next)
		 if(nm->name==co->name){
			 fprintf(stderr,"Duplicate coordinate name %s in 1st coordinate system.\n",
								nm->name->n);
			 fatal_error("Specification error\n");
		 }
	for(i=1;i<ncoords;i++)
	 for(gn=0;gn<i;gn++)
		 for(nm=coords[i].c_names->next,rn=1;rn<coords[i].rank;rn++,nm=nm->next)
			 if(in_clst(nm->name,&coords[gn])){
				 fprintf(stderr,"Duplicate coordinate name %s between coordinates systems %d and %d.\n",
									nm->name->n,i,gn);
				 fatal_error("Specification error\n");
			 }
	
#ifdef RNPLDEBUG
fprintf(stderr,"Checked coordinates\n");
#endif

	/* add coord_difs and grid bases*/
	for(fn=0;fn<ncoords;fn++)
		for(i=0,co=coords[fn].c_names;i<coords[fn].rank;i++,co=co->next){
			fnm=new_string(strlen(co->name->n)+1);
			sprintf(fnm,"d%s",co->name->n);
			coord_difs[fn][i]=add_name(fnm);
			free(fnm);
		}
	for(fn=0;fn<ncoords;fn++)
		for(i=0,co=coords[fn].c_names->next;i<coords[fn].rank-1;i++,co=co->next){
			fnm=new_string(strlen(co->name->n)+1);
			sprintf(fnm,"N%s",co->name->n);
			grid_base[fn][i]=add_name(fnm);
			free(fnm);
		}

#ifdef RNPLDEBUG
fprintf(stderr,"Added cdifs and gbases\n");
#endif

	/* build table of parameters */
	pl=pd;
	np=new_param_dec();
	np->type=STRING;
	np->size=1;
	np->name=name_lookup("in_file");
	np->def=0;
	np->con=1;
	np->def_val.s_ar=new_s_ar(1);
	if(pl)
		add_param(pl,np);
	else pl=pd=np;

	np=new_param_dec();
	np->type=STRING;
	np->size=1;
	np->name=name_lookup("out_file");
	np->def=0;
	np->con=1;
	np->def_val.s_ar=new_s_ar(1);
	add_param(pl,np);

	np=new_param_dec();
	np->type=IVEC;
	np->size=5;
	np->name=name_lookup("output");
	np->def=1;
	np->con=0;
	np->def_val.i_ar=new_i_ar(5);
	np->def_val.i_ar[0]=1;
	np->def_val.i_ar[1]=-1;
	np->def_val.i_ar[2]=-1;
	np->def_val.i_ar[3]=1;
	np->def_val.i_ar[4]=0;
	add_param(pl,np);
	
	np=new_param_dec();
	np->type=INT;
	np->size=1;
	np->name=name_lookup("ser");
	np->def=1;
	np->con=1;
	np->def_val.i_ar=new_i_ar(1);
	np->def_val.i_ar[0]=0;
	add_param(pl,np);

	np=new_param_dec();
	np->type=INT;
	np->size=1;
	np->name=name_lookup("fout");
	np->def=1;
	np->con=1;
	np->def_val.i_ar=new_i_ar(1);
	np->def_val.i_ar[0]=0;
	add_param(pl,np);

	np=new_param_dec();
	np->type=INT;
	np->size=1;
	np->name=name_lookup("iter");
	np->def=1;
	np->con=1;
	np->def_val.i_ar=new_i_ar(1);
	np->def_val.i_ar[0]=100;
	add_param(pl,np);

	np=new_param_dec();
	np->type=FLOAT;
	np->size=1;
	np->name=name_lookup("start_t");
	np->def=1;
	np->con=1;
	np->def_val.f_ar=new_f_ar(1);
	np->def_val.f_ar[0]=0.0;
	add_param(pl,np);
 
	np=new_param_dec();
	np->type=FLOAT;
	np->size=1;
	np->name=name_lookup("epsiter");
	np->def=1;
	np->con=1;
	np->def_val.f_ar=new_f_ar(1);
	np->def_val.f_ar[0]=1.0e-5;
	add_param(pl,np);
 
	np=new_param_dec();
	np->type=FLOAT;
	np->size=1;
	np->name=name_lookup("lambda");
	np->def=1;
	np->con=1;
	np->def_val.f_ar=new_f_ar(1);
	np->def_val.f_ar[0]=0.5;
	add_param(pl,np);

	np=new_param_dec();
	np->type=INT;
	np->size=1;
	np->name=name_lookup("level");
	np->def=1;
	np->con=1;
	np->def_val.i_ar=new_i_ar(1);
	np->def_val.i_ar[0]=0;
	add_param(pl,np);

	np=new_param_dec();
	np->type=STRING;
	np->size=1;
	np->name=name_lookup("tag");
	np->def=1;
	np->con=1;
	np->def_val.s_ar=new_s_ar(1);
	np->def_val.s_ar[0]=new_string(1);
	np->def_val.s_ar[0][0]='\0';
	add_param(pl,np);
 
	np=new_param_dec();
	np->type=INT;
	np->size=1;
	np->name=name_lookup("s_step");
	np->def=1;
	np->con=1;
	np->def_val.i_ar=new_i_ar(1);
	np->def_val.i_ar[0]=0;
	add_param(pl,np);

	if(language==F77 || language==F90){
		np=new_param_dec();
		np->type=INT;
		np->size=1;
		np->name=name_lookup("memsiz");
		np->def=1;
		np->con=2;
		np->def_val.i_ar=new_i_ar(1);
		np->def_val.i_ar[0]=2000000;
		add_param(pl,np);
	}
	
	/* add grid base parameters */
	for(gn=0;gn<ncoords;gn++)
		for(i=0,co=coords[gn].c_names->next;i<coords[gn].rank-1;i++,co=co->next){
			fnm=new_string(strlen(co->name->n)+2);
			sprintf(fnm,"N%s0",co->name->n);
			np=new_param_dec();
			np->type=INT;
			np->size=1;
			np->con=1;
			np->name=add_name(fnm);
			free(fnm);
			np->def=1;
			np->def_val.i_ar=new_i_ar(1);
			np->def_val.i_ar[0]=3;
			add_param(pl,np);
		}

	for(pn=0;pl!=NULL;pl=pl->next,pn++);
	if((params=(param_table *)malloc((pn)*sizeof(param_table)))==NULL)
		fatal_error("Can't malloc param_table.");
	nparams=pn;
 
	for(pn=0,pl=pd;pl!=NULL;pl=pl->next,pn++){
		params[pn].type=pl->type;
		params[pn].size=pl->size;
		params[pn].name=pl->name;
		params[pn].con=pl->con;
		params[pn].def=pl->def;
		params[pn].def_val=pl->def_val;
	}


#ifdef RNPLDEBUG
fprintf(stderr,"setup parameters\n");
#endif

  /* build table of grids */
  for(gn=0,g=gd;g!=NULL;g=g->next,gn++);
  if(gn!=0){
  	if((grids=(grid_table *)malloc(gn*sizeof(grid_table)))==NULL)
	  	fatal_error("Can't malloc grid_table.");
	}else grids=NULL;
  ngrids=gn;
  for(--gn,g=gd;gn>=0;gn--,g=g->next){ /* reverse order */
	  BBH_I nc;
	 

#ifdef RNPLDEBUG
fprintf(stderr,"grid %s\n",g->name->n);
#endif

	  grids[gn].type=g->type;
	  grids[gn].name=g->name;
	  for(i=0;i<ncoords && coords[i].name != g->cname;i++);
	  if(i==ncoords){
	    fprintf(stderr,"Grid %s is defined on non-existant coordinate system %s.\n",g->name->n,
	    				g->cname->n);
		  fatal_error("Specification error.");
	  }else grids[gn].crds=&coords[i];

#ifdef RNPLDEBUG
fprintf(stderr,"grids[%d].crds->name->n=%s\n",gn,coords[i].name->n);
#endif

	  if(g->clst != NULL){

#ifdef RNPLDEBUG
fprintf(stderr,"clst not null\n");
#endif

		  for(nc=0,co=g->clst;co!=NULL;nc++,co=co->next); /* get number of coordinates */
		  for(i=0,co=g->clst;i<nc;i++,co=co->next)
			  if(!in_clst(co->name,grids[gn].crds) || !is_space(co->name)){
				  fprintf(stderr,"Coordinate %s for grid %s is not a spacial coordinate for system %s\n",
									 co->name->n,grids[gn].name->n,grids[gn].crds->name->n);
				  fatal_error("Bad grid declaration.");
			  }
		  grids[gn].clst=g->clst;
	  }else{

#ifdef RNPLDEBUG
fprintf(stderr,"clst null\n");
#endif

		  if(g->ireg==NULL){
			  nc=grids[gn].crds->rank-1;
			  grids[gn].clst=dup_clst(grids[gn].crds->c_names->next);
		  }
	  }
	 if(g->ireg != NULL){ 

#ifdef RNPLDEBUG
fprintf(stderr,"ireg not null\n");
#endif

		 for(i=0,p=g->ireg;p!=NULL;p=p->next,i++);
		 grids[gn].reg.rank=i;

#ifdef RNPLDEBUG
fprintf(stderr,"grids[%d].reg.rank=%d\n",gn,i);
#endif

		 if(g->clst==NULL){
			 nc=i;
			 grids[gn].clst=dup_clst(grids[gn].crds->c_names->next);
			 for(i=1,co=grids[gn].clst;i<nc;i++,co=co->next);
			 del_clst(co->next);
			 co->next=NULL;
		 }

#ifdef RNPLDEBUG
fprintf(stderr,"nc=%d\n",nc);
#endif

		 if(grids[gn].reg.rank != nc){
			 fprintf(stderr,"Grid %s has conflicting ranks %d and %d.\n",
							 grids[gn].name->n,nc,grids[gn].reg.rank);
			 fatal_error("Bad grid declaration.");
		 }
		 grids[gn].reg.bounds=g->ireg;
		 for(i=0,q=g->creg;q!=NULL;q=q->next,i++);
		 if(i!=grids[gn].reg.rank){
			 fprintf(stderr,"Grid %s has rank %d for bounds and %d for limits.\n",
							 grids[gn].name->n,grids[gn].reg.rank,i);
			 fatal_error("Bad grid declaration.");
		 }
		 grids[gn].reg.limits=g->creg;
	 }else{ /* use defaults */
		 i_reg *ir;
		 c_reg *cr;
		 node *n;
		 BBH_I i;
		 

#ifdef RNPLDEBUG
fprintf(stderr,"ireg null\n");
#endif

		 grids[gn].reg.rank=nc;
		 ir=new_i_reg();
		 cr=new_c_reg();
		 grids[gn].reg.bounds=ir;
		 grids[gn].reg.limits=cr;
		 for(i=0,nm=grids[gn].clst;i<nc;i++,nm=nm->next){
			 fnm=new_string(strlen(nm->name->n)+3);
		   sprintf(fnm,"%smin",nm->name->n);
			 cr->lower=name_lookup(fnm);
			 if(cr->lower==NULL){
				 fprintf(stderr,"Failed to declare %s\n",fnm);
				 fatal_error("Missing parameter declaration.");
			 }
			 sprintf(fnm,"%smax",nm->name->n);
			 cr->upper=name_lookup(fnm);
			 if(cr->upper==NULL){
				 fprintf(stderr,"Failed to declare %s\n",fnm);
				 fatal_error("Missing parameter declaration.");
			 }
			 n=new_node();
			 n->type=INUM;
			 if(language==C)
				 n->data.inum=0;
			 else n->data.inum=1;
			 ir->lower=n;
			 sprintf(fnm,"N%s",nm->name->n);
			 add_name(fnm);
			 n=new_node();
			 if(language==C){ /* Nc-1 */
				 n->type=OP;
				 n->data.op='-';
				 n->left=new_node();
				 n->left->type=IDEN;
				 n->left->data.name=name_lookup(fnm);
				 n->right=new_node();
				 n->right->type=INUM;
				 n->right->data.inum=1;
			 }else{ /* Nc */
				 n->type=IDEN;
				 n->data.name=name_lookup(fnm);
			 }
			 ir->upper=n;
			 if(i+1 < nc){
				 ir->next=new_i_reg();
				 cr->next=new_c_reg();
				 ir=ir->next;
				 cr=cr->next;
			 }
			 free(fnm);
		 }
	 }
 }


#ifdef RNPLDEBUG
fprintf(stderr,"setup grids\n");
#endif

	/* build table of gfunctions */
	for(fn=0,f=gf;f!=NULL;f=f->next,fn++);
	if(fn!=0){
		if((gfuncs=(gfunc_table *)malloc(fn*sizeof(gfunc_table)))==NULL)
			fatal_error("Can't malloc gfunc_table.");
	}else gfuncs=NULL;
	ngfuncs=fn;
	for(--fn,f=gf;fn>=0;fn--,f=f->next){ /* reverse order */
		offset_type *ot;
		gfuncs[fn].type=f->type;
		gfuncs[fn].alias=f->alias;
		gfuncs[fn].fname=f->fname;
		for(gn=0;gn<ngrids && f->gname!=grids[gn].name;gn++);
		if(gn==ngrids){
			fprintf(stderr,"Error: gfunction %s defined on non-existant grid\n",f->fname->n);
			fatal_error("Bad grid function declaration.");
		}
		gfuncs[fn].grd=&grids[gn];
		gfuncs[fn].tlev=f->tlev;
		for(gfuncs[fn].ntlevs=0,ot=gfuncs[fn].tlev;ot!=NULL;ot=ot->next,gfuncs[fn].ntlevs++);
		gfuncs[fn].desc=f->desc;
		if(gfuncs[fn].ntlevs<2 && gfuncs[fn].alias==1){
			fprintf(stderr,"Error: gfunction %s cannot be aliased since it has only one time level\n",
							gfuncs[fn].fname->n);
			fatal_error("Bad grid function declaration.");
		}
		if(gfuncs[fn].ntlevs==0){
			gfuncs[fn].ntlevs=1;
			gfuncs[fn].tlev=new_offset();
			gfuncs[fn].tlev->offset=FLAG;
		}
	}


#ifdef RNPLDEBUG
fprintf(stderr,"setup gfuncs\n");
#endif

 /* build table of derivative operators */
	for(dn=0,o=od;o!=NULL;o=o->next,dn++);
	if(dn!=0){
		if((dopers=(dop_table *)malloc(dn*sizeof(dop_table)))==NULL)
			fatal_error("Can't malloc dop_table.");
	}else dopers=NULL;
	nopers=dn;
	for(dn=0,o=od;dn<nopers;dn++,o=o->next){
		offset_type *ot;
		bounds *bd;
		dopers[dn].name=o->deriv->name;
		dopers[dn].expr=o->deriv->expr;
		if(dopers[dn].expr->type != IDEN){
			dop_to_string(stderr,o->deriv);
			fprintf(stderr,"\n");
			fatal_error("Specification error -- illegal derivative operator definition.");
		}
		dopers[dn].clst=o->deriv->clst;
		dopers[dn].op_expr=o->op_expr;
		dopers[dn].tlev=find_tlevs(o->op_expr);
		for(dopers[dn].ntlevs=0,ot=dopers[dn].tlev;ot!=NULL;ot=ot->next,dopers[dn].ntlevs++);
		dopers[dn].indx=find_indx(o->op_expr);
		for(dopers[dn].ndim=0,bd=dopers[dn].indx;bd!=NULL;bd=bd->next,dopers[dn].ndim++);
	}
	for(dn=0;dn<nopers;dn++){ /* check coordinate lists */
		BBH_I i,res=1,j;
		coord_list *n1;
	 
		for(i=0,n1=dopers[dn].clst->c_names;i<dopers[dn].clst->rank;i++,n1=n1->next){
			res*=is_coord(n1->name);
		}
		if(!res){
			fprintf(stderr,"Error: Bad coordinates in derivative operator ");
			fprintf(stderr,"%s(",dopers[dn].name->n);
			ex_to_string(stderr,dopers[dn].expr);
			fprintf(stderr,",");
			for(i=0,n1=dopers[dn].clst->c_names;i<dopers[dn].clst->rank-1;i++,n1=n1->next)
				fprintf(stderr,"%s,",n1->name->n);
			fprintf(stderr,"%s).\n",n1->name->n);
			fatal_error("Bad derivative operator definition.");
		}
	}


#ifdef RNPLDEBUG
fprintf(stderr,"setup operators\n");
#endif

 /* build table of residuals */
	for(rn=0,r=rd;r!=NULL;r=r->next)
		for(rl=r->res;rl!=NULL;rl=rl->next,rn++);
	if(rn!=0){
		if((resids=(res_table *)malloc(rn*sizeof(res_table)))==NULL)
			fatal_error("Can't malloc res_table.");
	}else resids=NULL;
	nresids=rn;
	for(--rn,r=rd;rn>=0;r=r->next){ /* reverse order */
		for(rl=r->res;rl!=NULL;rl=rl->next,rn--){
			dop_ref_list *dl;
			gfunc_table *gf;
			if((gf=name_to_gfunc(r->name))==NULL){
				fprintf(stderr,"Error: residual defined for non-existant function %s\n",r->name->n);
				fatal_error("Bad residual definition.");
			}
			resids[rn].gf_refs=resids[rn].glob_gf=NULL;
			resids[rn].crds=resids[rn].glob_crds=NULL;
			resids[rn].cdifs=resids[rn].glob_cdifs=NULL;
			resids[rn].parms=resids[rn].glob_par=NULL;
			resids[rn].gfunc=gf;
			resids[rn].eval=r->eval;
			resids[rn].toff=r->toff;
			resids[rn].indx=r->indx;
			resids[rn].reg=rl->reg;
			resids[rn].etype=rl->etype;
			resids[rn].elst=rl->elst;
			resids[rn].output=0;
			if(resids[rn].etype==1)
				resids[rn].dop_refs=find_dops(resids[rn].elst.expr);
			else resids[rn].dop_refs=find_dops_if(resids[rn].elst.ifst);
			for(dl=resids[rn].dop_refs;dl!=NULL;dl=dl->next){
				gfunc_ref_list *gl;
				gl=dl->gf_refs;
				if(gl!=NULL)
					dl->grd=gl->gfunc->grd;
				else dl->grd=NULL;
				while(gl!=NULL){
					if(gl->gfunc->grd != dl->grd){
						fprintf(stderr,"In residual %s\n",resids[rn].gfunc->fname->n);
						fatal_error("Grid functions in derivative are defined on different grids.");
					}
					gl=gl->next;
				}
			}
		}
	}
 

#ifdef RNPLDEBUG
fprintf(stderr,"setup residuals\n");
#endif

 /* must come after residuals so get_size_one and get_size_all know about
 		which functions have residuals */
 al=ad;
 na=new_attrib_dec();
 na->type=INT;
 na->encoding=ENCODEONE;
 na->name=name_lookup("out_gf");
 na->def=1;
 if(al)
 	add_attrib(al,na);
 else al=ad=na;

 /* build table of attributes */
 for(nattribs=0;al!=NULL;al=al->next,nattribs++);
 if((attribs=(attrib_table *)malloc(nattribs*sizeof(attrib_table)))==NULL)
	 fatal_error("Can't malloc attrib_table.");

#ifdef RNPLDEBUG
fprintf(stderr,"nattribs: %d  attribs: %x\n",nattribs,attribs);
#endif

 for(an=0,al=ad;an<nattribs;al=al->next,an++){
	 scalar_list *p;

	 attribs[an].type=al->type;
	 switch(al->encoding){
		 case ENCODEONE : attribs[an].size=get_size_one();
											break;
		 case ENCODEALL : attribs[an].size=get_size_all();
											break;
	 }
		attribs[an].encoding=al->encoding;
		attribs[an].name=al->name;
		attribs[an].def=al->def;
		switch(attribs[an].type){
			case FLOAT	:	attribs[an].def_val.f_ar=new_f_ar(attribs[an].size);
										if(attribs[an].def && al->def_val){
											for(p=al->def_val,i=attribs[an].size-1;i>=0 && p!=NULL;i--,p=p->next)
												attribs[an].def_val.f_ar[i]=p->sc.data.num;
											if(i>=0){
												fprintf(stderr,"The initialization vector for attribute %s is too short.\n",
																attribs[an].name->n);
												fprintf(stderr,"It should contain %d elements\n",attribs[an].size);
												fatal_error("Specification error.");
											}
										}else if(attribs[an].def){
											for(i=0;i<attribs[an].size;i++)
												attribs[an].def_val.f_ar[i]=0.0;
 										}
										break;
			case INT		:	attribs[an].def_val.i_ar=new_i_ar(attribs[an].size);
										if(attribs[an].def && al->def_val){
											for(p=al->def_val,i=attribs[an].size-1;i>=0 && p!=NULL;i--,p=p->next)
												attribs[an].def_val.i_ar[i]=p->sc.data.inum;
											if(i>=0){
												fprintf(stderr,"The initialization vector for attribute %s is too short.\n",
																attribs[an].name->n);
												fprintf(stderr,"It should contain %d elements\n",attribs[an].size);
												fatal_error("Specification error.");
											}
										}else if(attribs[an].def){
											for(i=0;i<attribs[an].size;i++)
												attribs[an].def_val.i_ar[i]=0;
										}
										break;
			case STRING	:	attribs[an].def_val.s_ar=new_s_ar(attribs[an].size);
										if(attribs[an].def && al->def_val){
											for(p=al->def_val,i=attribs[an].size-1;i>=0 && p!=NULL;i--,p=p->next)
													attribs[an].def_val.s_ar[i]=p->sc.data.str;
											if(i>=0){
												fprintf(stderr,"The initialization vector for attribute %s is too short.\n",
																attribs[an].name->n);
												fprintf(stderr,"It should contain %d elements\n",attribs[an].size);
												fatal_error("Specification error.");
											}
										}else if(attribs[an].def){
											for(i=0;i<attribs[an].size;i++)
												attribs[an].def_val.s_ar[i]=NULL;
										}
										break;
		}

	}


#ifdef RNPLDEBUG
fprintf(stderr,"setup attributes\n");
#endif

 /* build table of initializations */
	for(i=0,ind=id;ind!=NULL;ind=ind->next)
 		for(rl=ind->init;rl!=NULL;rl=rl->next,i++);
	ninits=i;
	if(ninits!=0){
		if((inits=(init_table *)malloc(i*sizeof(init_table)))==NULL)
			fatal_error("Can't malloc init_table.");
	}else inits=NULL;
	for(--i,ind=id;i>=0;ind=ind->next){ /* reverse order */
	 	for(rl=ind->init;rl!=NULL;rl=rl->next,i--){
			if((inits[i].gfunc=name_to_gfunc(ind->name))==NULL){
				fprintf(stderr,"Error: initialization defined for non-existant function %s\n",ind->name->n);
				fatal_error("Bad initialization definition.");
			}
		 	inits[i].reg=rl->reg;
		 	inits[i].etype=rl->etype;
		 	inits[i].elst=rl->elst;
		}
	}					 


#ifdef RNPLDEBUG
fprintf(stderr,"setup initializations\n");
#endif

	loop_driver=ld;
	if(loop_driver==NULL)
		loop_driver=add_name("standard");

#ifdef RNPLDEBUG
fprintf(stderr,"setup loop driver\n");
#endif
		
	/* build table of updates */
	for(gn=0,u=ud;u!=NULL;u=u->next,gn++);
	nupdates=gn;
	if(nupdates!=0){
		if((updates=(update_table *)malloc(gn*sizeof(update_table)))==NULL)
			fatal_error("Can't malloc update_table.");
	}else updates=NULL;
	for(--gn,u=ud;gn>=0;gn--,u=u->next){ /* reverse order */
		if(u->refs)
			updates[gn].header=1;
		else updates[gn].header=0;
		updates[gn].glob_gf=NULL;
		updates[gn].glob_crds=NULL;
		updates[gn].glob_cdifs=NULL;
		updates[gn].glob_par=NULL;
		updates[gn].work_refs=NULL;
		updates[gn].type=u->type;
		updates[gn].name=u->name;
		updates[gn].gfs=new_gfunc_tab();
		for(gft=updates[gn].gfs,nm=u->gfs;nm!=NULL;nm=nm->next){
	  	gft->gfunc=name_to_gfunc(nm->name);
			if(gft->gfunc==NULL){
				fprintf(stderr,"Error: update %d defined for non-existant grid function %s\n",gn,nm->name->n);
				fatal_error("Bad update definition.");
			}
			if(nm->next != NULL){
		  	gft->next=new_gfunc_tab();
				gft=gft->next;
			}else gft->next=NULL;
		}
		if(u->refs){
			ref_list *rfl;
			gfunc_ref_list *gl;
			coord_list *cl;
			gfunc_table *gf;
			offset_type *o;
			work_list *wk;
			param_ref_list *pr;
			
			for(rfl=u->refs;rfl!=NULL;rfl=rfl->next){
				switch(rfl->type){
					case	IDEN	:	
#ifdef RNPLDEBUG
fprintf(stderr,"updates: rfl->type=IDEN\n");
fprintf(stderr,"  rfl->data.nref->name=%s\n",rfl->data.nref->name->n);
#endif
												switch(name_type(rfl->data.nref->name)){
													case	GFUNC	:	
#ifdef RNPLDEBUG
fprintf(stderr,"  %s is a GFUNC\n",rfl->data.nref->name->n);
#endif
																				gf=name_to_gfunc(rfl->data.nref->name);
																				for(cl=rfl->data.nref->subs,i=0,o=gf->tlev;
																						i<gf->ntlevs;i++,o=o->next){
#ifdef RNPLDEBUG
fprintf(stderr,"  toff=%d\n",o->offset);
#endif
																					gl=new_gfunc_ref();
																					gl->gfunc=gf;
																					gl->toff=o->offset;
																					if(cl){
																						if(i==0 && !cl->next)
																							gl->array=1;
																						gl->name=cl->name;
																						cl=cl->next;
																					}
																					if(updates[gn].glob_gf)
																						add_gfunc_ref(updates[gn].glob_gf,gl);
																					else updates[gn].glob_gf=gl;
																				}
																				if(i==0){
																					gl=new_gfunc_ref();
																					gl->gfunc=gf;
																					gl->toff=FLAG;
																					if(updates[gn].glob_gf)
																						add_gfunc_ref(updates[gn].glob_gf,gl);
																					else updates[gn].glob_gf=gl;
																				}
																				break;
													case	COORD	:	
#ifdef RNPLDEBUG
fprintf(stderr,"  %s is a COORD\n",rfl->data.nref->name->n);
#endif
																				cl=new_coord_list();
																				cl->name=rfl->data.nref->name;
																				if(updates[gn].glob_crds)
																					add_name_ref(updates[gn].glob_crds,cl);
																				else updates[gn].glob_crds=cl;
																				break;
													case	CDIF	:	
#ifdef RNPLDEBUG
fprintf(stderr,"  %s is a CDIF\n",rfl->data.nref->name->n);
#endif
																				cl=new_coord_list();
																				cl->name=rfl->data.nref->name;
																				if(updates[gn].glob_cdifs)
																					add_name_ref(updates[gn].glob_cdifs,cl);
																				else updates[gn].glob_cdifs=cl;
																				break;
													case	PARAM	:	
#ifdef RNPLDEBUG
fprintf(stderr,"  %s is a PARAM\n",rfl->data.nref->name->n);
#endif
																				pr=new_param_ref();
																				for(i=0;i<nparams && 
																						params[i].name!=rfl->data.nref->name;i++);
																				if(i==nparams)
																					fatal_error("Funky goings on.");
																				pr->par=&params[i];
																				if(updates[gn].glob_par)
																					add_param_ref(updates[gn].glob_par,pr);
																				else updates[gn].glob_par=pr;
																				break;
												}
												break;
					case	WORK	:	
#ifdef RNPLDEBUG
fprintf(stderr,"updates: rfl->type=WORK\n");
fprintf(stderr,"  rfl->data.work->num=%d\n",rfl->data.work->num);
#endif
												wk=new_work_list();
												wk->work=rfl->data.work;
												if(updates[gn].work_refs)
													add_work_ref(updates[gn].work_refs,wk);
												else updates[gn].work_refs=wk;
												break;
				}
			}
		}
	}

#ifdef RNPLDEBUG
fprintf(stderr,"setup updates\n");
#endif

}
yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 197,
	322, 0,
	-2, 90,
-1, 201,
	325, 0,
	326, 0,
	-2, 96,
-1, 202,
	325, 0,
	326, 0,
	-2, 97,
-1, 203,
	327, 0,
	328, 0,
	329, 0,
	330, 0,
	-2, 98,
-1, 204,
	327, 0,
	328, 0,
	329, 0,
	330, 0,
	-2, 99,
-1, 205,
	327, 0,
	328, 0,
	329, 0,
	330, 0,
	-2, 100,
-1, 206,
	327, 0,
	328, 0,
	329, 0,
	330, 0,
	-2, 101,
	};
# define YYNPROD 144
# define YYLAST 726
yytabelem yyact[]={

   278,   138,   139,   141,   142,   279,   143,   141,   142,   143,
   143,   295,   263,   160,   262,   179,   267,   266,   239,   246,
   238,   163,    27,   268,   121,   126,   120,   118,   221,   140,
   151,   150,   144,   145,   147,   146,   149,   148,   138,   139,
   141,   142,   311,   143,   140,   151,   150,   144,   145,   147,
   146,   149,   148,   138,   139,   141,   142,   310,   143,   260,
   121,   189,   120,   118,   292,   271,   211,   140,   151,   150,
   144,   145,   147,   146,   149,   148,   138,   139,   141,   142,
    49,   143,   140,   151,   150,   144,   145,   147,   146,   149,
   148,   138,   139,   141,   142,   299,   143,   127,   119,   140,
   151,   150,   144,   145,   147,   146,   149,   148,   138,   139,
   141,   142,   277,   143,   249,   192,   111,   140,   151,   150,
   144,   145,   147,   146,   149,   148,   138,   139,   141,   142,
   188,   143,   223,   297,   119,   293,   272,   212,    67,    85,
   217,   140,   151,   150,   144,   145,   147,   146,   149,   148,
   138,   139,   141,   142,   172,   143,   140,   151,   150,   144,
   145,   147,   146,   149,   148,   138,   139,   141,   142,   209,
   143,   140,   151,   150,   144,   145,   147,   146,   149,   148,
   138,   139,   141,   142,   160,   143,   193,   112,   296,    68,
    92,    91,    67,   106,   140,   151,   150,   144,   145,   147,
   146,   149,   148,   138,   139,   141,   142,    69,   143,   298,
   157,   108,   158,    81,   155,   140,   151,   150,   144,   145,
   147,   146,   149,   148,   138,   139,   141,   142,   294,   143,
   140,   151,   150,   144,   145,   147,   146,   149,   148,   138,
   139,   141,   142,    68,   143,   151,   150,   144,   145,   147,
   146,   149,   148,   138,   139,   141,   142,   280,   143,   150,
   144,   145,   147,   146,   149,   148,   138,   139,   141,   142,
   258,   143,   144,   145,   147,   146,   149,   148,   138,   139,
   141,   142,   276,   143,   147,   146,   149,   148,   138,   139,
   141,   142,    27,   143,    27,   102,   103,   102,   103,   133,
    93,    27,    34,    35,    36,    85,    30,    31,   157,    85,
   158,    85,    13,    26,    25,   274,    21,   251,   229,    46,
   132,    46,    28,    29,   218,    85,    20,   284,   307,    62,
   228,    96,   166,    96,    14,   113,    85,    76,   134,   243,
    71,   309,   300,    19,   273,   247,    23,    24,   226,    22,
    49,   222,    49,   177,   167,    63,    15,   109,    73,    33,
   237,   176,   242,   236,   178,    85,    94,    95,    94,    95,
   105,    27,   244,    77,    27,   219,   135,    61,    54,    50,
    38,    37,    64,   186,    27,   190,    34,    35,    36,   125,
   174,   173,    39,   162,   302,   152,   153,   154,   136,   301,
   288,    46,   289,   187,   286,   285,   283,   161,   248,   245,
   165,   168,   123,   270,    27,   117,    72,   184,   183,   156,
    59,   175,     2,    80,     1,   124,   107,   214,    10,   305,
   231,   100,   104,     7,     3,    12,    98,     4,     6,   195,
   196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
   206,   207,   208,   269,    48,   101,   210,    16,    32,   213,
     5,    90,    17,    18,    97,   220,   191,    99,     9,    11,
     8,     0,    40,    41,    42,    78,    45,    47,    43,    51,
    52,    53,    86,    75,    88,    44,     0,     0,    55,    56,
   291,     0,   114,     0,     0,    60,    57,    58,   116,    65,
     0,     0,    70,   115,     0,    66,    74,   129,     0,   171,
    60,     0,   308,    83,    84,     0,     0,    60,    87,    60,
    89,   312,     0,   254,   255,     0,     0,     0,   110,     0,
     0,     0,     0,    60,     0,     0,     0,     0,     0,     0,
   169,   131,     0,     0,   180,     0,   182,     0,     0,     0,
     0,     0,     0,     0,   275,     0,     0,     0,     0,   194,
   159,    79,    82,   227,     0,     0,     0,     0,   233,   234,
   170,     0,     0,     0,     0,     0,     0,     0,   290,   215,
     0,   216,     0,     0,   225,     0,   122,     0,   185,   128,
   130,   230,   232,   224,     0,     0,   137,   303,   304,     0,
   306,     0,     0,   235,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   164,     0,    60,     0,   256,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   185,     0,
     0,     0,     0,     0,   250,   181,     0,     0,   252,     0,
     0,     0,     0,   257,     0,   240,   241,   261,     0,     0,
     0,     0,   282,   281,   264,   259,     0,     0,   265,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    60,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   185,    60,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   287,   253 };
yytabelem yypact[]={

-10000000,    44,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,    40,   113,   112,   127,   157,   157,   124,
   117,  -235,   107,   157,   157,   157,   105,-10000000,-10000000,-10000000,
-10000000,-10000000,   157,   157,-10000000,-10000000,-10000000,   124,   124,   157,
   104,    63,   115,   157,  -133,   -89,   157,    46,    66,-10000000,
  -235,    43,-10000000,   100,   157,   -79,  -133,   157,   157,    74,
-10000000,   157,   157,   157,   157,  -110,    37,-10000000,-10000000,    37,
  -103,    65,   157,  -145,    41,    66,    65,   157,    74,  -198,
  -133,   151,  -236,   -79,  -133,   157,    14,    65,    45,   118,
  -133,-10000000,-10000000,   -92,    37,    37,    37,-10000000,-10000000,-10000000,
-10000000,   -82,-10000000,-10000000,   157,  -107,    37,  -283,  -133,    37,
    38,    61,   150,    65,   157,  -283,  -152,-10000000,-10000000,   130,
-10000000,-10000000,    69,    60,    73,  -317,-10000000,-10000000,  -198,  -133,
  -198,-10000000,   114,  -233,   119,-10000000,  -146,    69,    37,    37,
    37,    37,    37,    37,    37,    37,    37,    37,    37,    37,
    37,    37,  -327,  -327,  -128,    37,-10000000,  -195,    37,    16,
   157,  -151,    29,    65,    35,  -166,    65,    66,    55,  -283,
    36,    23,   114,-10000000,-10000000,-10000000,  -198,-10000000,  -236,  -236,
-10000000,    69,-10000000,    72,-10000000,    68,  -287,  -289,-10000000,   157,
   157,    81,-10000000,   148,-10000000,  -326,  -326,   -78,  -327,  -327,
  -327,   -43,   -43,  -330,  -330,  -330,  -330,   -53,   -65,-10000000,
  -278,    52,   147,  -181,    16,-10000000,    20,   157,-10000000,  -133,
   -92,-10000000,    37,    37,  -283,-10000000,    66,   -25,    65,-10000000,
    72,  -234,-10000000,  -318,  -322,-10000000,   114,   157,  -291,  -292,
  -275,    65,   155,-10000000,  -196,-10000000,-10000000,-10000000,    51,-10000000,
-10000000,-10000000,    18,    35,  -205,  -293,   -38,-10000000,-10000000,  -283,
-10000000,-10000000,  -236,   145,-10000000,    34,   144,   143,   157,  -233,
-10000000,-10000000,   141,-10000000,-10000000,   -92,-10000000,    37,    65,  -197,
-10000000,   -67,  -323,-10000000,-10000000,  -108,  -163,   -86,-10000000,-10000000,
  -223,-10000000,    49,   138,-10000000,   133,    37,    37,  -233,    35,
    65,    48,-10000000,  -240,  -255,-10000000,   -92,-10000000,-10000000,    65,
-10000000,-10000000,-10000000 };
yytabelem yypgo[]={

     0,   470,   211,   455,   469,   420,   300,   468,   426,   467,
   130,   466,   416,   432,   463,   458,   462,   423,   461,   389,
   460,   438,   437,   464,   436,   435,   434,   433,   431,   415,
   430,   421,   428,   418,   417,   419,   427,    28,   425,   424,
   422,   505,   393 };
yytabelem yyr1[]={

     0,    39,    39,    40,    40,    40,    40,    40,    40,    40,
    40,    40,    40,    26,    26,    26,    26,    26,    26,    26,
    26,    26,    26,    26,    22,    20,    20,    20,    20,    21,
    21,    21,    21,    21,    21,    27,    27,     1,     7,     7,
     7,     7,    32,     4,    25,    25,    25,    15,    15,    15,
     3,    29,    29,    29,    29,    29,    17,    41,    41,    31,
    38,    38,    38,    38,    38,    38,     5,     5,    16,    16,
     2,     2,     2,     2,     2,     2,    10,    10,    14,    14,
    11,    11,    11,    11,    18,    18,    23,    23,     6,     6,
     6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     6,     8,     8,     8,     8,    42,    42,    13,    12,
    12,    12,    12,    33,    33,    30,    30,    19,    19,    24,
     9,    28,    37,    37,    37,    34,    34,    34,    34,    36,
    36,    35,    35,    35 };
yytabelem yyr2[]={

     0,     0,     4,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     7,    11,     9,    13,     7,    11,     9,
    13,    11,    15,    13,     7,    13,     9,    19,    15,     9,
    11,    13,    15,    15,    17,     9,    13,     9,    13,    17,
    15,    19,    13,     5,    13,    13,     7,     3,     3,     3,
     3,     3,     5,     3,     5,     3,     7,     2,     2,     7,
     3,     7,    11,     7,    11,    15,     3,     7,     3,     3,
    11,    13,    15,    17,    17,    19,    11,    13,     3,     3,
     3,     5,     7,     9,     3,     3,    13,    15,     7,     7,
     7,     7,     7,     7,     5,     5,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     3,     3,     3,     3,     3,
     3,     3,     7,    11,     7,    11,     0,     2,     3,     7,
     9,     9,    11,     3,     7,     3,     5,     3,     3,     9,
     7,     5,     9,    13,    13,     3,     9,    15,    15,     3,
     5,     7,     9,     7 };
yytabelem yychk[]={

-10000000,   -39,   -40,   -26,   -22,   -20,   -21,   -27,    -1,    -7,
   -32,    -4,   -25,   268,   290,   312,    -3,   -16,   -14,   299,
   282,   272,   305,   302,   303,   270,   269,   257,   278,   279,
   262,   263,   -15,   319,   262,   263,   264,   268,   268,   265,
    -3,    -3,    -3,   -15,   -23,    -3,   284,    -3,   -13,   315,
   272,    -3,    -3,    -3,   273,    -3,    -3,   -15,   -15,    -5,
    -3,   273,   266,   292,   267,    -3,   -41,   271,   322,   296,
    -3,   294,   -12,   292,    -3,   -13,   294,   273,    -5,   -41,
   -17,   292,   -41,    -3,    -3,   291,    -5,    -3,    -5,    -3,
   -18,   301,   300,    -6,   331,   332,   296,   -23,   -24,    -9,
   -28,    -3,   260,   261,   -13,    -6,   296,    -8,    -2,   292,
    -3,   261,   332,   294,   -12,    -8,    -5,   -29,   261,   332,
   260,   258,   -41,   261,   -38,   -19,   261,   333,   -41,   -17,
   -41,    -3,   306,    -2,   293,   258,   280,   -41,   331,   332,
   322,   333,   334,   336,   325,   326,   328,   327,   330,   329,
   324,   323,    -6,    -6,    -6,   296,   -35,   292,   294,    -3,
   291,    -6,   -42,   304,   -41,    -6,   294,   293,   261,    -8,
    -3,   -42,   306,   261,   260,   -31,   292,   293,   291,   332,
   -29,   -41,   -29,   -33,   -34,    -3,   269,   289,   -10,   294,
   266,   -11,   261,   332,   -31,    -6,    -6,    -6,    -6,    -6,
    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,   297,
    -6,   261,   332,    -6,   -36,   -35,    -5,   291,   295,    -2,
    -6,   -37,   316,   298,    -8,   -12,   293,   -42,   294,   295,
   -33,   -30,   -29,   -19,   -19,   -31,   291,   292,   307,   307,
    -3,    -3,   281,   258,   291,   261,   297,   293,   261,   295,
   -35,   297,    -5,   -41,    -6,    -6,   -42,   -12,   295,    -8,
   293,   -29,   332,   334,   -34,    -5,   308,   308,   298,    -2,
   258,   261,   332,   293,   297,    -6,   -37,   317,   293,   298,
   295,   -42,   -19,   261,   293,   261,   261,    -3,   -10,   261,
    -6,    -2,   261,   332,   295,   334,   296,   296,   295,   318,
   293,   261,   261,    -6,    -6,   -10,    -6,   -37,    -2,   293,
   297,   297,    -2 };
yytabelem yydef[]={

     1,    -2,     2,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    50,    68,    69,
    78,    79,     0,     0,    47,    48,    49,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   118,
     0,     0,    43,     0,     0,    13,    17,     0,     0,    24,
    66,     0,     0,     0,     0,     0,     0,    57,    58,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    46,     0,
    15,     0,     0,    19,     0,     0,     0,    26,     0,    29,
    35,    84,    85,    37,     0,     0,     0,   105,   106,   107,
   108,   109,   110,   111,     0,     0,     0,   116,     0,     0,
     0,     0,     0,     0,     0,   116,     0,    14,    51,     0,
    53,    55,     0,     0,    18,    60,   127,   128,     0,    21,
     0,    67,     0,     0,     0,    30,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    94,    95,     0,     0,   131,     0,     0,     0,
     0,     0,     0,   117,     0,     0,     0,   119,     0,   116,
     0,     0,     0,    52,    54,    16,     0,    56,     0,     0,
    20,     0,    23,    44,   123,   135,     0,     0,    25,     0,
     0,    31,    80,     0,    36,    88,    89,    -2,    91,    92,
    93,    -2,    -2,    -2,    -2,    -2,    -2,   102,   103,   104,
     0,     0,     0,     0,   130,   139,     0,     0,    38,     0,
   112,   114,     0,     0,   116,   121,   120,     0,     0,    42,
    45,     0,   125,    63,    61,    22,     0,     0,     0,     0,
     0,    28,    32,    33,     0,    81,   129,   141,     0,   143,
   140,    86,     0,     0,     0,     0,     0,   122,    40,   116,
    59,   126,     0,     0,   124,     0,     0,     0,     0,     0,
    34,    82,     0,   142,    87,   113,   115,     0,    70,     0,
    39,     0,    64,    62,   136,     0,     0,     0,    27,    83,
   132,    71,     0,     0,    41,     0,     0,     0,    76,     0,
    72,     0,    65,     0,     0,    77,   133,   134,    74,    73,
   137,   138,    75 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"IDEN",	257,
	"STR",	258,
	"OP",	259,
	"NUM",	260,
	"INUM",	261,
	"INT",	262,
	"FLOAT",	263,
	"STRING",	264,
	"COORDINATES",	265,
	"GRID",	266,
	"ON",	267,
	"PARAM",	268,
	"AUTO",	269,
	"STUB",	270,
	"ASSIGNOP",	271,
	"RESID",	272,
	"UPDATE",	273,
	"C",	274,
	"CPP",	275,
	"F77",	276,
	"F90",	277,
	"UNIFORM",	278,
	"NONUNIFORM",	279,
	"AT",	280,
	"ALIAS",	281,
	"OPERATOR",	282,
	"QUOTE",	283,
	"EXPAND",	284,
	"FUNC",	285,
	"D_OP",	286,
	"GFUNC",	287,
	"COORD",	288,
	"STATIC",	289,
	"CONST",	290,
	"COMMA",	291,
	"OBRACK",	292,
	"CBRACK",	293,
	"OBRACE",	294,
	"CBRACE",	295,
	"OPAREN",	296,
	"CPAREN",	297,
	"COLON",	298,
	"ATTRIB",	299,
	"ENCODEALL",	300,
	"ENCODEONE",	301,
	"INITIALIZE",	302,
	"LOOPER",	303,
	"SCOLON",	304,
	"EVALUATE",	305,
	"HEADER",	306,
	"WORK",	307,
	"POUND",	308,
	"UPFILE",	309,
	"CDIF",	310,
	"GBASE",	311,
	"SYS",	312,
	"OFFS",	313,
	"EXPR",	314,
	"TIME",	315,
	"IF",	316,
	"THEN",	317,
	"ELSE",	318,
	"IVEC",	319,
	"RNPL",	320,
	"DAGH",	321,
	"EQUALS",	322,
	"OR",	323,
	"AND",	324,
	"EQUIV",	325,
	"NOTEQ",	326,
	"GREAT",	327,
	"LESS",	328,
	"GREATEQ",	329,
	"LESSEQ",	330,
	"PLUS",	331,
	"MINUS",	332,
	"TIMES",	333,
	"DIVIDE",	334,
	"UMINUS",	335,
	"CARET",	336,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"dec_list : /* empty */",
	"dec_list : dec_list declaration",
	"declaration : param_dec",
	"declaration : coord_dec",
	"declaration : grid_dec",
	"declaration : gfunc_dec",
	"declaration : attrib_dec",
	"declaration : d_operator",
	"declaration : residual",
	"declaration : initialization",
	"declaration : looper",
	"declaration : update",
	"param_dec : PARAM p_type name",
	"param_dec : PARAM p_type name becomes scalar",
	"param_dec : PARAM p_type name v_size",
	"param_dec : PARAM p_type name v_size becomes vector",
	"param_dec : PARAM IVEC name",
	"param_dec : PARAM IVEC name becomes ivec_list",
	"param_dec : CONST PARAM p_type name",
	"param_dec : CONST PARAM p_type name becomes scalar",
	"param_dec : CONST PARAM p_type name v_size",
	"param_dec : CONST PARAM p_type name v_size becomes vector",
	"param_dec : SYS PARAM p_type name becomes scalar",
	"coord_dec : name COORDINATES coord_list",
	"grid_dec : g_type name GRID name i_region c_region",
	"grid_dec : g_type name GRID name",
	"grid_dec : g_type name OBRACK coord_list CBRACK GRID name i_region c_region",
	"grid_dec : g_type name OBRACK coord_list CBRACK GRID name",
	"gfunc_dec : type name ON name",
	"gfunc_dec : type name ON name STR",
	"gfunc_dec : type name ON name AT o_list",
	"gfunc_dec : type name ON name AT o_list ALIAS",
	"gfunc_dec : type name ON name AT o_list STR",
	"gfunc_dec : type name ON name AT o_list ALIAS STR",
	"attrib_dec : ATTRIB p_type name encoding",
	"attrib_dec : ATTRIB p_type name encoding becomes vector",
	"d_operator : OPERATOR d_op becomes expr",
	"residual : RESID name OBRACE res_list opcolon CBRACE",
	"residual : RESID time index name OBRACE res_list opcolon CBRACE",
	"residual : EVALUATE RESID name OBRACE res_list opcolon CBRACE",
	"residual : EVALUATE RESID time index name OBRACE res_list opcolon CBRACE",
	"initialization : INITIALIZE name OBRACE res_list opcolon CBRACE",
	"looper : LOOPER name",
	"update : name name UPDATE coord_list HEADER ref_list",
	"update : STUB name UPDATE coord_list HEADER ref_list",
	"update : AUTO UPDATE coord_list",
	"p_type : INT",
	"p_type : FLOAT",
	"p_type : STRING",
	"name : IDEN",
	"scalar : INUM",
	"scalar : MINUS INUM",
	"scalar : NUM",
	"scalar : MINUS NUM",
	"scalar : STR",
	"v_size : OBRACK INUM CBRACK",
	"becomes : ASSIGNOP",
	"becomes : EQUALS",
	"vector : OBRACK scalar_list CBRACK",
	"ivec_list : ivel",
	"ivec_list : ivel MINUS ivel",
	"ivec_list : ivel MINUS ivel DIVIDE INUM",
	"ivec_list : ivec_list COMMA ivel",
	"ivec_list : ivec_list COMMA ivel MINUS ivel",
	"ivec_list : ivec_list COMMA ivel MINUS ivel DIVIDE INUM",
	"coord_list : name",
	"coord_list : coord_list COMMA name",
	"g_type : UNIFORM",
	"g_type : NONUNIFORM",
	"i_region : OBRACK expr COLON expr CBRACK",
	"i_region : OBRACK expr COLON expr CBRACK i_region",
	"i_region : OBRACK expr COLON expr COLON INUM CBRACK",
	"i_region : OBRACK expr COLON expr COLON MINUS INUM CBRACK",
	"i_region : OBRACK expr COLON expr COLON INUM CBRACK i_region",
	"i_region : OBRACK expr COLON expr COLON MINUS INUM CBRACK i_region",
	"c_region : OBRACE name COLON name CBRACE",
	"c_region : OBRACE name COLON name CBRACE c_region",
	"type : INT",
	"type : FLOAT",
	"o_list : INUM",
	"o_list : MINUS INUM",
	"o_list : o_list COMMA INUM",
	"o_list : o_list COMMA MINUS INUM",
	"encoding : ENCODEONE",
	"encoding : ENCODEALL",
	"d_op : name OPAREN expr COMMA coord_list CPAREN",
	"d_op : EXPAND name OPAREN expr COMMA coord_list CPAREN",
	"expr : expr PLUS expr",
	"expr : expr MINUS expr",
	"expr : expr EQUALS expr",
	"expr : expr TIMES expr",
	"expr : expr DIVIDE expr",
	"expr : expr CARET expr",
	"expr : PLUS expr",
	"expr : MINUS expr",
	"expr : expr EQUIV expr",
	"expr : expr NOTEQ expr",
	"expr : expr LESS expr",
	"expr : expr GREAT expr",
	"expr : expr LESSEQ expr",
	"expr : expr GREATEQ expr",
	"expr : expr AND expr",
	"expr : expr OR expr",
	"expr : OPAREN expr CPAREN",
	"expr : d_op",
	"expr : func",
	"expr : gfunc",
	"expr : coord",
	"expr : name",
	"expr : NUM",
	"expr : INUM",
	"res_list : i_region becomes expr",
	"res_list : res_list SCOLON i_region becomes expr",
	"res_list : i_region becomes ifstat",
	"res_list : res_list SCOLON i_region becomes ifstat",
	"opcolon : /* empty */",
	"opcolon : SCOLON",
	"time : TIME",
	"index : OBRACK INUM CBRACK",
	"index : OBRACK MINUS INUM CBRACK",
	"index : OBRACK INUM CBRACK index",
	"index : OBRACK MINUS INUM CBRACK index",
	"ref_list : reference",
	"ref_list : ref_list COMMA reference",
	"scalar_list : scalar",
	"scalar_list : scalar_list scalar",
	"ivel : INUM",
	"ivel : TIMES",
	"func : name OPAREN expr CPAREN",
	"gfunc : time name mindex",
	"coord : name indel",
	"ifstat : IF expr THEN expr",
	"ifstat : IF expr THEN expr ELSE expr",
	"ifstat : IF expr THEN expr ELSE ifstat",
	"reference : name",
	"reference : name OBRACK coord_list CBRACK",
	"reference : AUTO WORK POUND INUM OPAREN expr CPAREN",
	"reference : STATIC WORK POUND INUM OPAREN expr CPAREN",
	"mindex : indel",
	"mindex : mindex indel",
	"indel : OBRACK INUM CBRACK",
	"indel : OBRACK MINUS INUM CBRACK",
	"indel : OBRACE expr CBRACE",
};
#endif /* YYDEBUG */
/* 
 *	Copyright 1987 Silicon Graphics, Inc. - All Rights Reserved
 */

/* #ident	"@(#)yacc:yaccpar	1.10" */
#ident	"$Revision: 1.10 $"

/*
** Skeleton parser driver for yacc output
*/
#include "stddef.h"

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#ifdef __cplusplus
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( gettxt("uxlibc:78", "syntax error - cannot backup") );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#else
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( gettxt("uxlibc:78", "Syntax error - cannot backup") );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#endif
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
#ifdef __cplusplus
			yyerror(gettxt("uxlibc:79", "yacc initialization error"));
#else
			yyerror(gettxt("uxlibc:79", "Yacc initialization error"));
#endif
			YYABORT;
		}
	}
#endif

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			int yynewmax;
			ptrdiff_t yys_off;

			/* The following pointer-differences are safe, since
			 * yypvt, yy_pv, and yypv all are a multiple of
			 * sizeof(YYSTYPE) bytes from yyv.
			 */
			ptrdiff_t yypvt_off = yypvt - yyv;
			ptrdiff_t yy_pv_off = yy_pv - yyv;
			ptrdiff_t yypv_off = yypv - yyv;

			int *yys_base = yys;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				void *newyys = YYNEW(int);
				void *newyyv = YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
#ifdef __cplusplus
				yyerror( gettxt("uxlibc:80", "yacc stack overflow") );
#else
				yyerror( gettxt("uxlibc:80", "Yacc stack overflow") );
#endif
				YYABORT;
			}
			yymaxdepth = yynewmax;

			/* reset pointers into yys */
			yys_off = yys - yys_base;
			yy_ps = yy_ps + yys_off;
			yyps = yyps + yys_off;

			/* reset pointers into yyv */
			yypvt = yyv + yypvt_off;
			yy_pv = yyv + yy_pv_off;
			yypv = yyv + yypv_off;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
#ifdef __cplusplus
				yyerror( gettxt("uxlibc:81", "syntax error") );
#else
				yyerror( gettxt("uxlibc:81", "Syntax error") );
#endif
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
				/* FALLTHRU */
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 119 "rnpl.y"
{
								if(pd==NULL)
									pd=yypvt[-0].pdec;
								else add_param(pd,yypvt[-0].pdec);
							} break;
case 4:
# line 124 "rnpl.y"
{
			if(cd==NULL)
				cd=yypvt[-0].crdec;
			else {
				yypvt[-0].crdec->next=cd;
				cd=yypvt[-0].crdec;
			}
		} break;
case 5:
# line 132 "rnpl.y"
{
			if(gd==NULL)
				gd=yypvt[-0].grlst;
			else {
				yypvt[-0].grlst->next=gd;
				gd=yypvt[-0].grlst;
			}
		} break;
case 6:
# line 140 "rnpl.y"
{
			if(gf==NULL)
				gf=yypvt[-0].gfnlst;
			else {
				yypvt[-0].gfnlst->next=gf;
				gf=yypvt[-0].gfnlst;
			}
		} break;
case 7:
# line 148 "rnpl.y"
{
			if(ad==NULL)
				ad=yypvt[-0].atdec;
			else add_attrib(ad,yypvt[-0].atdec);
		} break;
case 8:
# line 153 "rnpl.y"
{
			if(od==NULL)
				od=yypvt[-0].doper;
			else {
				yypvt[-0].doper->next=od;
				od=yypvt[-0].doper;
			}
		} break;
case 9:
# line 161 "rnpl.y"
{
			if(rd==NULL)
				rd=yypvt[-0].resid;
			else {
				yypvt[-0].resid->next=rd;
				rd=yypvt[-0].resid;
			}
		} break;
case 10:
# line 169 "rnpl.y"
{
			if(id==NULL)
				id=yypvt[-0].indec;
			else {
				yypvt[-0].indec->next=id;
				id=yypvt[-0].indec;
			}
		} break;
case 11:
# line 177 "rnpl.y"
{
			if(ld==NULL)
				ld=yypvt[-0].nml;
			else yyerror("Only one looper declaration is permitted.");
		} break;
case 12:
# line 182 "rnpl.y"
{
			if(ud==NULL)
				ud=yypvt[-0].updt;
			else {
				yypvt[-0].updt->next=ud;
				ud=yypvt[-0].updt;
			}
		} break;
case 13:
# line 192 "rnpl.y"
{
						 yyval.pdec=new_param_dec();
						 yyval.pdec->type=yypvt[-1].inum;
						 yyval.pdec->size=1;
						 yyval.pdec->con=0;
						 yyval.pdec->name=yypvt[-0].nml;
						 yyval.pdec->def=0;
						 switch(yyval.pdec->type){
							 case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(1);
														break;
							 case INT		: yyval.pdec->def_val.i_ar=new_i_ar(1);
														break;
							 case STRING: yyval.pdec->def_val.s_ar=new_s_ar(1);
														break;
						 }
					 } break;
case 14:
# line 208 "rnpl.y"
{
						yyval.pdec=new_param_dec();
						yyval.pdec->type=yypvt[-3].inum;
						yyval.pdec->size=1;
						yyval.pdec->con=0;
						yyval.pdec->name=yypvt[-2].nml;
						yyval.pdec->def=1;
						switch(yyval.pdec->type){
							case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(1);
													 if(yypvt[-0].sclr.type==INT)
													   yyval.pdec->def_val.f_ar[0]=(BBH_D)yypvt[-0].sclr.data.inum;
													 else 
														 yyval.pdec->def_val.f_ar[0]=yypvt[-0].sclr.data.num;
													 break;
							case INT	 : yyval.pdec->def_val.i_ar=new_i_ar(1);
													 if(yypvt[-0].sclr.type==INT)
													   yyval.pdec->def_val.i_ar[0]=yypvt[-0].sclr.data.inum;
													 else {
														 fprintf(stderr,"parameter %s delared int, but assigned float.\n",yyval.pdec->name->n);
														 yyerror("Parameter Specification");
													 }
													 break;
							case STRING: yyval.pdec->def_val.s_ar=new_s_ar(1);
													 if(yypvt[-0].sclr.type==STRING)
														 yyval.pdec->def_val.s_ar[0]=yypvt[-0].sclr.data.str;
													 else {
														 fprintf(stderr,"parameter %s delared string, but assigned a number.\n",yyval.pdec->name->n);
														 yyerror("Parameter Specification");
													 }
													 break;
						}
					} break;
case 15:
# line 240 "rnpl.y"
{
						yyval.pdec=new_param_dec();
						yyval.pdec->type=yypvt[-2].inum;
						yyval.pdec->size=yypvt[-0].inum;
						yyval.pdec->con=0;
						yyval.pdec->name=yypvt[-1].nml;
						yyval.pdec->def=0;
						switch(yyval.pdec->type){
							case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(yyval.pdec->size);
													 break;
							case INT	 : yyval.pdec->def_val.i_ar=new_i_ar(yyval.pdec->size);
													 break;
							case STRING: yyval.pdec->def_val.s_ar=new_s_ar(yyval.pdec->size);
													 break;
						}
					} break;
case 16:
# line 256 "rnpl.y"
{
						BBH_I i;
						scalar_list *p;
						yyval.pdec=new_param_dec();
						yyval.pdec->type=yypvt[-4].inum;
						yyval.pdec->size=yypvt[-2].inum;
						yyval.pdec->con=0;
						yyval.pdec->name=yypvt[-3].nml;
						yyval.pdec->def=1;
						switch(yyval.pdec->type){
							case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(yyval.pdec->size);
													 for(p=yypvt[-0].sclrlst,i=yyval.pdec->size-1;i>=0;i--,p=p->next)
														 if(p->sc.type==FLOAT)
														   yyval.pdec->def_val.f_ar[i]=p->sc.data.num;
														 else if(p->sc.type==INT)
														   yyval.pdec->def_val.f_ar[i]=(BBH_D)p->sc.data.inum;
														 else yyerror("bad parameter declaration");
													 break;
							case INT	 : yyval.pdec->def_val.i_ar=new_i_ar(yyval.pdec->size);
													 for(p=yypvt[-0].sclrlst,i=yyval.pdec->size-1;i>=0;i--,p=p->next)
													   if(p->sc.type==INT)
														   yyval.pdec->def_val.i_ar[i]=p->sc.data.inum;
														 else yyerror("bad parameter declaration");
													 break;
							case STRING: yyval.pdec->def_val.s_ar=new_s_ar(yyval.pdec->size);
													 for(p=yypvt[-0].sclrlst,i=yyval.pdec->size-1;i>=0;i--,p=p->next)
													   if(p->sc.type==STRING)
														   yyval.pdec->def_val.s_ar[i]=p->sc.data.str;
														 else yyerror("bad parameter declaration");
													 break;
						}
					} break;
case 17:
# line 288 "rnpl.y"
{
			yyval.pdec=new_param_dec();
			yyval.pdec->type=yypvt[-1].inum;
			yyval.pdec->size=IVEL+1;
			yyval.pdec->con=0;
			yyval.pdec->name=yypvt[-0].nml;
			yyval.pdec->def=0;
		} break;
case 18:
# line 296 "rnpl.y"
{
			BBH_I c;
			ivec_list *p;
			yyval.pdec=new_param_dec();
			yyval.pdec->type=yypvt[-3].inum;
			yyval.pdec->con=0;
			yyval.pdec->name=yypvt[-2].nml;
			yyval.pdec->def=1;
			for(c=0,p=yypvt[-0].ivlst;p!=NULL;p=p->next,c++);
			yyval.pdec->def_val.i_ar=new_i_ar(IVEL*c+1);
			yyval.pdec->def_val.i_ar[0]=c;
			yyval.pdec->size=IVEL*c+1;
			for(c=1,p=yypvt[-0].ivlst;p!=NULL;p=p->next){
				yyval.pdec->def_val.i_ar[c++]=p->low;
				yyval.pdec->def_val.i_ar[c++]=p->high;
				yyval.pdec->def_val.i_ar[c++]=p->mod;
				yyval.pdec->def_val.i_ar[c++]=0;
			}
		} break;
case 19:
# line 315 "rnpl.y"
{
						 yyval.pdec=new_param_dec();
						 yyval.pdec->type=yypvt[-1].inum;
						 yyval.pdec->size=1;
						 yyval.pdec->con=1;
						 yyval.pdec->name=yypvt[-0].nml;
						 yyval.pdec->def=0;
						 switch(yyval.pdec->type){
							 case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(1);
														break;
							 case INT		: yyval.pdec->def_val.i_ar=new_i_ar(1);
														break;
							 case STRING: yyval.pdec->def_val.s_ar=new_s_ar(1);
														break;
						 }
					 } break;
case 20:
# line 331 "rnpl.y"
{
						yyval.pdec=new_param_dec();
						yyval.pdec->type=yypvt[-3].inum;
						yyval.pdec->size=1;
						yyval.pdec->con=1;
						yyval.pdec->name=yypvt[-2].nml;
						yyval.pdec->def=1;
						switch(yyval.pdec->type){
							case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(1);
													 if(yypvt[-0].sclr.type==INT)
													   yyval.pdec->def_val.f_ar[0]=(BBH_D)yypvt[-0].sclr.data.inum;
													 else 
														 yyval.pdec->def_val.f_ar[0]=yypvt[-0].sclr.data.num;
													 break;
							case INT	 : yyval.pdec->def_val.i_ar=new_i_ar(1);
													 if(yypvt[-0].sclr.type==INT)
													   yyval.pdec->def_val.i_ar[0]=yypvt[-0].sclr.data.inum;
													 else {
														 fprintf(stderr,"parameter %s delared int, but assigned float.\n",yyval.pdec->name->n);
														 yyerror("Parameter Specification");
													 }
													 break;
							case STRING: yyval.pdec->def_val.s_ar=new_s_ar(1);
													 if(yypvt[-0].sclr.type==STRING)
														 yyval.pdec->def_val.s_ar[0]=yypvt[-0].sclr.data.str;
													 else {
														 fprintf(stderr,"parameter %s delared string, but assigned a number.\n",yyval.pdec->name->n);
														 yyerror("Parameter Specification");
													 }
													 break;
						}
					} break;
case 21:
# line 363 "rnpl.y"
{
						yyval.pdec=new_param_dec();
						yyval.pdec->type=yypvt[-2].inum;
						yyval.pdec->size=yypvt[-0].inum;
						yyval.pdec->con=1;
						yyval.pdec->name=yypvt[-1].nml;
						yyval.pdec->def=0;
						switch(yyval.pdec->type){
							case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(yyval.pdec->size);
													 break;
							case INT	 : yyval.pdec->def_val.i_ar=new_i_ar(yyval.pdec->size);
													 break;
							case STRING: yyval.pdec->def_val.s_ar=new_s_ar(yyval.pdec->size);
													 break;
						}
					} break;
case 22:
# line 379 "rnpl.y"
{
						BBH_I i;
						scalar_list *p;
						yyval.pdec=new_param_dec();
						yyval.pdec->type=yypvt[-4].inum;
						yyval.pdec->size=yypvt[-2].inum;
						yyval.pdec->con=1;
						yyval.pdec->name=yypvt[-3].nml;
						yyval.pdec->def=1;
						switch(yyval.pdec->type){
							case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(yyval.pdec->size);
													 for(p=yypvt[-0].sclrlst,i=yyval.pdec->size-1;i>=0;i--,p=p->next)
														 if(p->sc.type==FLOAT)
														   yyval.pdec->def_val.f_ar[i]=p->sc.data.num;
														 else if(p->sc.type==INT)
														   yyval.pdec->def_val.f_ar[i]=(BBH_D)p->sc.data.inum;
														 else yyerror("bad parameter declaration");
													 break;
							case INT	 : yyval.pdec->def_val.i_ar=new_i_ar(yyval.pdec->size);
													 for(p=yypvt[-0].sclrlst,i=yyval.pdec->size-1;i>=0;i--,p=p->next)
													   if(p->sc.type==INT)
														   yyval.pdec->def_val.i_ar[i]=p->sc.data.inum;
														 else yyerror("bad parameter declaration");
													 break;
							case STRING: yyval.pdec->def_val.s_ar=new_s_ar(yyval.pdec->size);
													 for(p=yypvt[-0].sclrlst,i=yyval.pdec->size-1;i>=0;i--,p=p->next)
													   if(p->sc.type==STRING)
														   yyval.pdec->def_val.s_ar[i]=p->sc.data.str;
														 else yyerror("bad parameter declaration");
													 break;
						}
					} break;
case 23:
# line 411 "rnpl.y"
{
						yyval.pdec=new_param_dec();
						yyval.pdec->type=yypvt[-3].inum;
						yyval.pdec->size=1;
						yyval.pdec->con=2;
						yyval.pdec->name=yypvt[-2].nml;
						yyval.pdec->def=1;
						switch(yyval.pdec->type){
							case FLOAT : yyval.pdec->def_val.f_ar=new_f_ar(1);
													 if(yypvt[-0].sclr.type==INT)
													   yyval.pdec->def_val.f_ar[0]=(BBH_D)yypvt[-0].sclr.data.inum;
													 else 
														 yyval.pdec->def_val.f_ar[0]=yypvt[-0].sclr.data.num;
													 break;
							case INT	 : yyval.pdec->def_val.i_ar=new_i_ar(1);
													 if(yypvt[-0].sclr.type==INT)
													   yyval.pdec->def_val.i_ar[0]=yypvt[-0].sclr.data.inum;
													 else {
														 fprintf(stderr,"parameter %s delared int, but assigned float.\n",yyval.pdec->name->n);
														 yyerror("Parameter Specification");
													 }
													 break;
							case STRING: yyval.pdec->def_val.s_ar=new_s_ar(1);
													 if(yypvt[-0].sclr.type==STRING)
														 yyval.pdec->def_val.s_ar[0]=yypvt[-0].sclr.data.str;
													 else {
														 fprintf(stderr,"parameter %s delared string, but assigned a number.\n",yyval.pdec->name->n);
														 yyerror("Parameter Specification");
													 }
													 break;
						}
					} break;
case 24:
# line 445 "rnpl.y"
{ 
						 coord_list *p;
						 yyval.crdec=new_coord_dec();
						 yyval.crdec->name=yypvt[-2].nml;
						 for(yyval.crdec->rank=0,p=yypvt[-0].crd;p!=NULL;p=p->next,yyval.crdec->rank++);
						 yyval.crdec->c_names=yypvt[-0].crd;
					 } break;
case 25:
# line 454 "rnpl.y"
{
						yyval.grlst=new_grid_list();
						yyval.grlst->type=yypvt[-5].inum;
						yyval.grlst->cname=yypvt[-4].nml;
						yyval.grlst->name=yypvt[-2].nml;
						yyval.grlst->ireg=yypvt[-1].ireg;
						yyval.grlst->creg=yypvt[-0].creg;
					} break;
case 26:
# line 462 "rnpl.y"
{
			yyval.grlst=new_grid_list();
			yyval.grlst->type=yypvt[-3].inum;
			yyval.grlst->cname=yypvt[-2].nml;
			yyval.grlst->name=yypvt[-0].nml;
		} break;
case 27:
# line 468 "rnpl.y"
{
			yyval.grlst=new_grid_list();
			yyval.grlst->type=yypvt[-8].inum;
			yyval.grlst->cname=yypvt[-7].nml;
			yyval.grlst->clst=yypvt[-5].crd;
			yyval.grlst->name=yypvt[-2].nml;
			yyval.grlst->ireg=yypvt[-1].ireg;
			yyval.grlst->creg=yypvt[-0].creg;
		} break;
case 28:
# line 477 "rnpl.y"
{
			yyval.grlst=new_grid_list();
			yyval.grlst->type=yypvt[-6].inum;
			yyval.grlst->cname=yypvt[-5].nml;
			yyval.grlst->clst=yypvt[-3].crd;
			yyval.grlst->name=yypvt[-0].nml;
		} break;
case 29:
# line 486 "rnpl.y"
{
							yyval.gfnlst=new_gfunc_list();
							yyval.gfnlst->type=yypvt[-3].inum;
							yyval.gfnlst->alias=0;
							yyval.gfnlst->fname=yypvt[-2].nml;
							yyval.gfnlst->gname=yypvt[-0].nml;
						} break;
case 30:
# line 493 "rnpl.y"
{
			yyval.gfnlst=new_gfunc_list();
			yyval.gfnlst->type=yypvt[-4].inum;
			yyval.gfnlst->alias=0;
			yyval.gfnlst->fname=yypvt[-3].nml;
			yyval.gfnlst->gname=yypvt[-1].nml;
			yyval.gfnlst->desc=yypvt[-0].str;
		} break;
case 31:
# line 501 "rnpl.y"
{
			yyval.gfnlst=new_gfunc_list();
			yyval.gfnlst->type=yypvt[-5].inum;
			yyval.gfnlst->alias=0;
			yyval.gfnlst->fname=yypvt[-4].nml;
			yyval.gfnlst->gname=yypvt[-2].nml;
			yyval.gfnlst->tlev=yypvt[-0].olst;
		} break;
case 32:
# line 509 "rnpl.y"
{
			yyval.gfnlst=new_gfunc_list();
			yyval.gfnlst->type=yypvt[-6].inum;
			yyval.gfnlst->fname=yypvt[-5].nml;
			yyval.gfnlst->gname=yypvt[-3].nml;
			yyval.gfnlst->tlev=yypvt[-1].olst;
			yyval.gfnlst->alias=1;
		} break;
case 33:
# line 517 "rnpl.y"
{
			yyval.gfnlst=new_gfunc_list();
			yyval.gfnlst->type=yypvt[-6].inum;
			yyval.gfnlst->alias=0;
			yyval.gfnlst->fname=yypvt[-5].nml;
			yyval.gfnlst->gname=yypvt[-3].nml;
			yyval.gfnlst->tlev=yypvt[-1].olst;
			yyval.gfnlst->desc=yypvt[-0].str;
		} break;
case 34:
# line 526 "rnpl.y"
{
			yyval.gfnlst=new_gfunc_list();
			yyval.gfnlst->type=yypvt[-7].inum;
			yyval.gfnlst->fname=yypvt[-6].nml;
			yyval.gfnlst->gname=yypvt[-4].nml;
			yyval.gfnlst->tlev=yypvt[-2].olst;
			yyval.gfnlst->alias=1;
			yyval.gfnlst->desc=yypvt[-0].str;
		} break;
case 35:
# line 537 "rnpl.y"
{
						 yyval.atdec=new_attrib_dec();
						 yyval.atdec->type=yypvt[-2].inum;
						 yyval.atdec->encoding=yypvt[-0].inum;
						 yyval.atdec->name=yypvt[-1].nml;
						 yyval.atdec->def=0;
					 } break;
case 36:
# line 544 "rnpl.y"
{
						yyval.atdec=new_attrib_dec();
						yyval.atdec->type=yypvt[-4].inum;
						yyval.atdec->encoding=yypvt[-2].inum;
						yyval.atdec->name=yypvt[-3].nml;
						yyval.atdec->def=1;
						yyval.atdec->def_val=yypvt[-0].sclrlst;
					} break;
case 37:
# line 554 "rnpl.y"
{
							yyval.doper=new_operator();
							yyval.doper->deriv=yypvt[-2].deriv;
							yyval.doper->op_expr=yypvt[-0].nd;
						} break;
case 38:
# line 561 "rnpl.y"
{
						yyval.resid=new_residual();
						yyval.resid->eval=0;
						yyval.resid->name=yypvt[-4].nml;
						yyval.resid->res=yypvt[-2].rlst;
					} break;
case 39:
# line 567 "rnpl.y"
{
			yyval.resid=new_residual();
			yyval.resid->eval=0;
			yyval.resid->toff=yypvt[-6].inum;
			yyval.resid->indx=yypvt[-5].olst;
			yyval.resid->name=yypvt[-4].nml;
			yyval.resid->res=yypvt[-2].rlst;
		} break;
case 40:
# line 575 "rnpl.y"
{
			yyval.resid=new_residual();
			yyval.resid->eval=1;
			yyval.resid->name=yypvt[-4].nml;
			yyval.resid->res=yypvt[-2].rlst;
		} break;
case 41:
# line 581 "rnpl.y"
{
			yyval.resid=new_residual();
			yyval.resid->eval=1;
			yyval.resid->toff=yypvt[-6].inum;
			yyval.resid->indx=yypvt[-5].olst;
			yyval.resid->name=yypvt[-4].nml;
			yyval.resid->res=yypvt[-2].rlst;
		} break;
case 42:
# line 591 "rnpl.y"
{
									yyval.indec=new_init_dec();
									yyval.indec->name=yypvt[-4].nml;
									yyval.indec->init=yypvt[-2].rlst;
								} break;
case 43:
# line 598 "rnpl.y"
{
					yyval.nml=yypvt[-0].nml;
				} break;
case 44:
# line 603 "rnpl.y"
{
					yyval.updt=new_update();
					yyval.updt->type=yypvt[-5].nml;
					yyval.updt->name=yypvt[-4].nml;
					yyval.updt->gfs=yypvt[-2].crd;
					yyval.updt->refs=yypvt[-0].rflst;
				} break;
case 45:
# line 610 "rnpl.y"
{
			yyval.updt=new_update();
			yyval.updt->type=name_lookup("stub");
			yyval.updt->name=yypvt[-4].nml;
			yyval.updt->gfs=yypvt[-2].crd;
			yyval.updt->refs=yypvt[-0].rflst;
		} break;
case 46:
# line 617 "rnpl.y"
{
			yyval.updt=new_update();
			yyval.updt->type=name_lookup("auto");
			yyval.updt->gfs=yypvt[-0].crd;
		} break;
case 47:
# line 624 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 48:
# line 625 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 49:
# line 626 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 50:
# line 629 "rnpl.y"
{
				yyval.nml=add_name(yypvt[-0].ident);
			} break;
case 51:
# line 634 "rnpl.y"
{ 
					yyval.sclr.type=INT;
					yyval.sclr.data.inum=yypvt[-0].inum;
				} break;
case 52:
# line 638 "rnpl.y"
{
			yyval.sclr.type=INT;
			yyval.sclr.data.inum=-yypvt[-0].inum;
		} break;
case 53:
# line 642 "rnpl.y"
{
			yyval.sclr.type=FLOAT;
			yyval.sclr.data.num=yypvt[-0].num;
		} break;
case 54:
# line 646 "rnpl.y"
{
			yyval.sclr.type=FLOAT;
			yyval.sclr.data.num=-yypvt[-0].num;
		} break;
case 55:
# line 650 "rnpl.y"
{
			yyval.sclr.type=STRING;
			yyval.sclr.data.str=yypvt[-0].str;
		} break;
case 56:
# line 656 "rnpl.y"
{ yyval.inum=yypvt[-1].inum; } break;
case 59:
# line 662 "rnpl.y"
{ yyval.sclrlst=yypvt[-1].sclrlst; } break;
case 60:
# line 665 "rnpl.y"
{
							yyval.ivlst=new_ivec_list();
							yyval.ivlst->low=yypvt[-0].inum;
							yyval.ivlst->high=yypvt[-0].inum;
							yyval.ivlst->mod=1;
						} break;
case 61:
# line 671 "rnpl.y"
{
			yyval.ivlst=new_ivec_list();
			yyval.ivlst->low=yypvt[-2].inum;
			yyval.ivlst->high=yypvt[-0].inum;
			yyval.ivlst->mod=1;
		} break;
case 62:
# line 677 "rnpl.y"
{
			yyval.ivlst=new_ivec_list();
			yyval.ivlst->low=yypvt[-4].inum;
			yyval.ivlst->high=yypvt[-2].inum;
			yyval.ivlst->mod=yypvt[-0].inum;
		} break;
case 63:
# line 683 "rnpl.y"
{
			ivec_list *p;
			for(p=yypvt[-2].ivlst;p->next!=NULL;p=p->next);
			p->next=new_ivec_list();
			p->next->low=yypvt[-0].inum;
			p->next->high=yypvt[-0].inum;
			p->next->mod=1;
			yyval.ivlst=yypvt[-2].ivlst;
		} break;
case 64:
# line 692 "rnpl.y"
{
			ivec_list *p;
			for(p=yypvt[-4].ivlst;p->next!=NULL;p=p->next);
			p->next=new_ivec_list();
			p->next->low=yypvt[-2].inum;
			p->next->high=yypvt[-0].inum;
			p->next->mod=1;
			yyval.ivlst=yypvt[-4].ivlst;
		} break;
case 65:
# line 701 "rnpl.y"
{
			ivec_list *p;
			for(p=yypvt[-6].ivlst;p->next!=NULL;p=p->next);
			p->next=new_ivec_list();
			p->next->low=yypvt[-4].inum;
			p->next->high=yypvt[-2].inum;
			p->next->mod=yypvt[-0].inum;
			yyval.ivlst=yypvt[-6].ivlst;
		} break;
case 66:
# line 712 "rnpl.y"
{ 
							yyval.crd=new_coord_list();
							yyval.crd->name=yypvt[-0].nml;
						} break;
case 67:
# line 716 "rnpl.y"
{
			coord_list *p;
			for(p=yypvt[-2].crd;p->next!=NULL;p=p->next);
			p->next=new_coord_list();
			p->next->name=yypvt[-0].nml; 
			yyval.crd=yypvt[-2].crd; 
		} break;
case 68:
# line 725 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 69:
# line 726 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 70:
# line 729 "rnpl.y"
{ 
						yyval.ireg=new_i_reg();
						yyval.ireg->lower=yypvt[-3].nd;
						yyval.ireg->upper=yypvt[-1].nd;
						yyval.ireg->inc=1;
					} break;
case 71:
# line 735 "rnpl.y"
{ 
			yyval.ireg=new_i_reg();
			yyval.ireg->lower=yypvt[-4].nd;
			yyval.ireg->upper=yypvt[-2].nd;
			yyval.ireg->next=yypvt[-0].ireg;
			yyval.ireg->inc=1;
		} break;
case 72:
# line 742 "rnpl.y"
{ 
						yyval.ireg=new_i_reg();
						yyval.ireg->lower=yypvt[-5].nd;
						yyval.ireg->upper=yypvt[-3].nd;
						yyval.ireg->inc=yypvt[-1].inum;
		} break;
case 73:
# line 748 "rnpl.y"
{ 
						yyval.ireg=new_i_reg();
						yyval.ireg->lower=yypvt[-6].nd;
						yyval.ireg->upper=yypvt[-4].nd;
						yyval.ireg->inc=-yypvt[-1].inum;
		} break;
case 74:
# line 754 "rnpl.y"
{ 
			yyval.ireg=new_i_reg();
			yyval.ireg->lower=yypvt[-6].nd;
			yyval.ireg->upper=yypvt[-4].nd;
			yyval.ireg->inc=yypvt[-2].inum;
			yyval.ireg->next=yypvt[-0].ireg;
		} break;
case 75:
# line 761 "rnpl.y"
{ 
			yyval.ireg=new_i_reg();
			yyval.ireg->lower=yypvt[-7].nd;
			yyval.ireg->upper=yypvt[-5].nd;
			yyval.ireg->inc=-yypvt[-2].inum;
			yyval.ireg->next=yypvt[-0].ireg;
		} break;
case 76:
# line 770 "rnpl.y"
{
						yyval.creg=new_c_reg();
						yyval.creg->lower=yypvt[-3].nml; 
						yyval.creg->upper=yypvt[-1].nml; 
					} break;
case 77:
# line 775 "rnpl.y"
{ 
			yyval.creg=new_c_reg();
			yyval.creg->lower=yypvt[-4].nml;
			yyval.creg->upper=yypvt[-2].nml;
			yyval.creg->next=yypvt[-0].creg;
		} break;
case 78:
# line 783 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 79:
# line 784 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 80:
# line 787 "rnpl.y"
{ 
					yyval.olst=new_offset();
					yyval.olst->offset=yypvt[-0].inum;
				 } break;
case 81:
# line 791 "rnpl.y"
{ 
			yyval.olst=new_offset();
			yyval.olst->offset=-yypvt[-0].inum;
		} break;
case 82:
# line 795 "rnpl.y"
{
			offset_type *os;
			
			os=new_offset();
			os->offset=yypvt[-0].inum;
			add_offset(yypvt[-2].olst,os);
			yyval.olst=yypvt[-2].olst;
		} break;
case 83:
# line 803 "rnpl.y"
{ 
			offset_type *os;
			
			os=new_offset();
			os->offset=-yypvt[-0].inum;
			add_offset(yypvt[-3].olst,os);
			yyval.olst=yypvt[-3].olst;
		} break;
case 84:
# line 813 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 85:
# line 814 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 86:
# line 817 "rnpl.y"
{ 
				coord_list *p;
				yyval.deriv=new_dop();
				yyval.deriv->expand=FALSE;
				yyval.deriv->name=yypvt[-5].nml;
				yyval.deriv->expr=yypvt[-3].nd;
				yyval.deriv->clst=new_coord_tab();
				for(yyval.deriv->clst->rank=0,p=yypvt[-1].crd;p!=NULL;p=p->next,yyval.deriv->clst->rank++);
				yyval.deriv->clst->c_names=yypvt[-1].crd;
			} break;
case 87:
# line 827 "rnpl.y"
{
			coord_list *p;
			yyval.deriv=new_dop();
			yyval.deriv->expand=TRUE;
			yyval.deriv->name=yypvt[-5].nml;
			yyval.deriv->expr=yypvt[-3].nd;
			yyval.deriv->clst=new_coord_tab();
			for(yyval.deriv->clst->rank=0,p=yypvt[-1].crd;p!=NULL;p=p->next,yyval.deriv->clst->rank++);
			yyval.deriv->clst->c_names=yypvt[-1].crd;
		} break;
case 88:
# line 839 "rnpl.y"
{
				yyval.nd=new_node();
				yyval.nd->type=OP;
				yyval.nd->data.op=yypvt[-1].op;
				yyval.nd->left=yypvt[-2].nd;
				yyval.nd->right=yypvt[-0].nd;
			} break;
case 89:
# line 846 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 90:
# line 853 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op='-';
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 91:
# line 860 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 92:
# line 867 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 93:
# line 874 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 94:
# line 881 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 95:
# line 887 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 96:
# line 893 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 97:
# line 900 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 98:
# line 907 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 99:
# line 914 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 100:
# line 921 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 101:
# line 928 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 102:
# line 935 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 103:
# line 942 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=OP;
			yyval.nd->data.op=yypvt[-1].op;
			yyval.nd->left=yypvt[-2].nd;
			yyval.nd->right=yypvt[-0].nd;
		} break;
case 104:
# line 949 "rnpl.y"
{
			yyval.nd=yypvt[-1].nd;
		} break;
case 105:
# line 952 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=D_OP;
			yyval.nd->data.deriv=yypvt[-0].deriv;
		} break;
case 106:
# line 957 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=FUNC;
			yyval.nd->data.func=yypvt[-0].fnc;
		} break;
case 107:
# line 962 "rnpl.y"
{
			yyval.nd=new_node();
			yyval.nd->type=GFUNC;
			yyval.nd->data.gfunc=yypvt[-0].gfunc;
		} break;
case 108:
# line 967 "rnpl.y"
{ 
			yyval.nd=new_node();
			yyval.nd->type=COORD; 
			yyval.nd->data.coord=yypvt[-0].cdnt;
		} break;
case 109:
# line 972 "rnpl.y"
{ 
			yyval.nd=new_node();
			yyval.nd->type=IDEN; 
			yyval.nd->data.name=yypvt[-0].nml;
		} break;
case 110:
# line 977 "rnpl.y"
{ 
			yyval.nd=new_node();
			yyval.nd->type=NUM; 
			yyval.nd->data.num=yypvt[-0].num;
		} break;
case 111:
# line 982 "rnpl.y"
{ 
			yyval.nd=new_node();
			yyval.nd->type=INUM; 
			yyval.nd->data.inum=yypvt[-0].inum;
		} break;
case 112:
# line 989 "rnpl.y"
{
						yyval.rlst=new_res_list();
						yyval.rlst->reg=yypvt[-2].ireg;
						yyval.rlst->etype=1;
						yyval.rlst->elst.expr=yypvt[-0].nd;
					} break;
case 113:
# line 995 "rnpl.y"
{
			yyval.rlst=new_res_list();
			yyval.rlst->reg=yypvt[-2].ireg;
			yyval.rlst->etype=1;
			yyval.rlst->elst.expr=yypvt[-0].nd;
			yyval.rlst->next=yypvt[-4].rlst;
		} break;
case 114:
# line 1002 "rnpl.y"
{
						yyval.rlst=new_res_list();
						yyval.rlst->reg=yypvt[-2].ireg;
						yyval.rlst->etype=2;
						yyval.rlst->elst.ifst=yypvt[-0].ifs;
					} break;
case 115:
# line 1008 "rnpl.y"
{
			yyval.rlst=new_res_list();
			yyval.rlst->reg=yypvt[-2].ireg;
			yyval.rlst->etype=2;
			yyval.rlst->elst.ifst=yypvt[-0].ifs;
			yyval.rlst->next=yypvt[-4].rlst;
		} break;
case 118:
# line 1021 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 119:
# line 1024 "rnpl.y"
{ 
				 yyval.olst=new_offset();
				 yyval.olst->offset=yypvt[-1].inum;
			 } break;
case 120:
# line 1028 "rnpl.y"
{ 
			yyval.olst=new_offset();
			yyval.olst->offset=-yypvt[-1].inum;
		} break;
case 121:
# line 1032 "rnpl.y"
{ 
			yyval.olst=new_offset();
			yyval.olst->offset=yypvt[-2].inum;
			yyval.olst->next=yypvt[-0].olst;
		} break;
case 122:
# line 1037 "rnpl.y"
{ 
			yyval.olst=new_offset();
			yyval.olst->offset=-yypvt[-2].inum;
			yyval.olst->next=yypvt[-0].olst;
		} break;
case 123:
# line 1044 "rnpl.y"
{
						yyval.rflst=yypvt[-0].rflst;
					} break;
case 124:
# line 1047 "rnpl.y"
{
			yyval.rflst=yypvt[-0].rflst;
			yyval.rflst->next=yypvt[-2].rflst;
		} break;
case 125:
# line 1053 "rnpl.y"
{
							 yyval.sclrlst=new_scalar_list();
							 yyval.sclrlst->sc=yypvt[-0].sclr;
						 } break;
case 126:
# line 1057 "rnpl.y"
{
			yyval.sclrlst=new_scalar_list();
			yyval.sclrlst->sc=yypvt[-0].sclr;
			yyval.sclrlst->next=yypvt[-1].sclrlst;
		} break;
case 127:
# line 1064 "rnpl.y"
{ yyval.inum=yypvt[-0].inum; } break;
case 128:
# line 1065 "rnpl.y"
{ yyval.inum=-1; } break;
case 129:
# line 1068 "rnpl.y"
{
				yyval.fnc=new_func();
				yyval.fnc->name=yypvt[-3].nml;
				yyval.fnc->expr=yypvt[-1].nd;
			} break;
case 130:
# line 1075 "rnpl.y"
{ 
				 yyval.gfunc=new_gfunc();
				 yyval.gfunc->toff=yypvt[-2].inum;
				 yyval.gfunc->name=yypvt[-1].nml;
				 yyval.gfunc->indx=yypvt[-0].indl;
			 } break;
case 131:
# line 1083 "rnpl.y"
{
				 yyval.cdnt=new_coord();
				 yyval.cdnt->name=yypvt[-1].nml;
				 yyval.cdnt->indx=yypvt[-0].ndl;
			 } break;
case 132:
# line 1090 "rnpl.y"
{
					yyval.ifs=new_ifstat();
					yyval.ifs->lexpr=yypvt[-2].nd;
					yyval.ifs->expr=yypvt[-0].nd;
					yyval.ifs->etype=0;
				} break;
case 133:
# line 1096 "rnpl.y"
{
			yyval.ifs=new_ifstat();
			yyval.ifs->lexpr=yypvt[-4].nd;
			yyval.ifs->expr=yypvt[-2].nd;
			yyval.ifs->etype=1;
			yyval.ifs->elst.expr=yypvt[-0].nd;
		} break;
case 134:
# line 1103 "rnpl.y"
{
			yyval.ifs=new_ifstat();
			yyval.ifs->lexpr=yypvt[-4].nd;
			yyval.ifs->expr=yypvt[-2].nd;
			yyval.ifs->etype=2;
			yyval.ifs->elst.ifst=yypvt[-0].ifs;
		} break;
case 135:
# line 1112 "rnpl.y"
{
							yyval.rflst=new_ref_list();
							yyval.rflst->type=IDEN;
							yyval.rflst->data.nref=new_name_ref();
							yyval.rflst->data.nref->name=yypvt[-0].nml;
						} break;
case 136:
# line 1118 "rnpl.y"
{
			yyval.rflst=new_ref_list();
			yyval.rflst->type=IDEN;
			yyval.rflst->data.nref=new_name_ref();
			yyval.rflst->data.nref->name=yypvt[-3].nml;
			yyval.rflst->data.nref->subs=yypvt[-1].crd;
		} break;
case 137:
# line 1125 "rnpl.y"
{
			yyval.rflst=new_ref_list();
			yyval.rflst->type=WORK;
			yyval.rflst->data.work=new_work_array();
			yyval.rflst->data.work->ato=1;
			if(yypvt[-3].inum<0) yypvt[-3].inum=-yypvt[-3].inum;
			yyval.rflst->data.work->num=yypvt[-3].inum;
			yyval.rflst->data.work->expr=yypvt[-1].nd;
		} break;
case 138:
# line 1134 "rnpl.y"
{
			yyval.rflst=new_ref_list();
			yyval.rflst->type=WORK;
			yyval.rflst->data.work=new_work_array();
			yyval.rflst->data.work->ato=0;
			if(yypvt[-3].inum<0) yypvt[-3].inum=-yypvt[-3].inum;
			yyval.rflst->data.work->num=yypvt[-3].inum;
			yyval.rflst->data.work->expr=yypvt[-1].nd;
		} break;
case 139:
# line 1145 "rnpl.y"
{
					yyval.indl=new_index_list();
					yyval.indl->ind=yypvt[-0].ndl;
				} break;
case 140:
# line 1149 "rnpl.y"
{
			index_list *p;
			for(p=yypvt[-1].indl;p->next!=NULL;p=p->next);
			p->next=new_index_list();
			p->next->ind=yypvt[-0].ndl;
			yyval.indl=yypvt[-1].indl;
		} break;
case 141:
# line 1158 "rnpl.y"
{
					yyval.ndl=new_indel();
					yyval.ndl->type=OFFS;
					yyval.ndl->val.offset=yypvt[-1].inum;
				} break;
case 142:
# line 1163 "rnpl.y"
{
			yyval.ndl=new_indel();
			yyval.ndl->type=OFFS;
			yyval.ndl->val.offset=-yypvt[-1].inum;
		} break;
case 143:
# line 1168 "rnpl.y"
{
			yyval.ndl=new_indel();
			yyval.ndl->type=EXPR;
			yyval.ndl->val.expr=yypvt[-1].nd;
		} break;
	}
	goto yystack;		/* reset registers in driver code */
}
